import ads;
import trees;

real spread = 0.6;

int levels = 6;
int n = 2**(levels-1);
int m = 2*n-1;

pair u[] = complete_binary_tree(5, spread, levels);
tree_init(u);
vertex_size = 0.05;

// Kanonické ntervaly

path ival(int level, int index) {
	int ll = levels - 1 - level;
	int size = 2**ll;
	int start = index * size;
	real ht = 0.18;
	pair d = (u[n+1] - u[n]) * 0.4;
	return box( (u[n+start] + (0,ll*spread) - d) + (0,ht), (u[n+start+size-1] + (0,ll*spread) + d) - (0,ht));
}

for (int i=0; i<levels; ++i)
	for (int j=0; j<2**i; ++j)
		draw(ival(i, j), agray);

// Použité intervaly
path used[] = {
	ival(4, 9),
	ival(3, 5),
	ival(3, 6),
	ival(4, 14),
	ival(5, 30),
};
for (path p: used)
	fill(p, agray);

// Hrany
for (int i=2; i<=m; ++i)
	tree_edge((int)(i/2), i);

// Použité hrany
int visited[] = {
	1,
	3,
	6, 7,
	12, 13, 14, 15,
	25, 30, 31,
	62,
};
for (int i: visited)
	if (i>1) tree_edge((int)(i/2), i, thick);

// Vrcholy
for (int i=1; i<=m; ++i) {
	if (i < n)
		tree_node(i);
	else
		tree_ext(i, size=0.9);
}
label("$p$", u[3], 2.5E);

// Použité vrcholy
for (int i: visited) {
	if (i < n)
		tree_node(i, mode=v_black);
	else
		tree_ext(i, size=0.9, mode=v_black);
}

// Dotaz
int ii = 18;
int jj = 31;
pair pi = (u[n+ii] + u[n+ii-1]) / 2;
pair pj = (u[n+jj] + u[n+jj-1]) / 2;
pair s = (0, 0.55);
pair t = (0, 0.65);
draw( pi-s -- pi-t -- pj-t -- pj-s );
pair t2 = (0, 0.07);
label("\strut $\ell$", u[n+ii] - t2, S);
label("\strut $r$", u[n+jj-1] - t2, S);
