import ads;
import trees;

pair d = bst_edge;
pair l1 = d + (-1.8, 0);
pair r1 = d + (1.8, 0);
pair l2 = d + (-1.2, 0);
pair r2 = d + (1.2, 0);
pair l3 = d + (-1, 0);
pair r3 = d + (1, 0);
pair l4 = d + (-0.3, 0);
pair r4 = d + (0.3, 0);

pair u[];
u[0] = (0, 0);
u[1] = u[0] + l1;	// k
u[2] = u[0] + r1;	// m
u[3] = u[1] + l2;	// ko
u[4] = u[3] + l3;	// koc
u[5] = u[3] + r3;	// koz
u[6] = u[4] + l4;	// kock
u[7] = u[4] + r4;	// kocu
u[8] = u[6] + d;	// kocka
u[9] = u[7] + d;	// kocur
u[10] = u[5] + l4;	// koza
u[11] = u[5] + r4;	// koze
u[12] = u[11] + d;	// kozel
u[13] = u[3] + d;	// kot
u[14] = u[13] + d;	// kote
u[15] = u[1] + r2;	// ku
u[16] = u[15] + d;	// kuz
u[17] = u[16] + d;	// kuzl
u[18] = u[17] + d;	// kuzle
u[19] = u[2] + d;	// my
u[20] = u[19] + d;	// mys
u[21] = u[20] + l4;	// mysa
u[22] = u[20] + r4;	// mysk
u[23] = u[21] + d;	// mysak
u[24] = u[22] + d;	// myska

int endings[] = { 8, 9, 14, 10, 12, 18, 20, 23, 24 };

tree_node_size = 0.1;
tree_init(u);

void te(int i, int j, string s, pair d)
{
	edge(i, j);
	label("\tt " + s, 0.5(u[i]+u[j]), d);
}

te(0, 1, "k", S*unit(l1));
te(0, 2, "m", N*unit(r1));
te(1, 3, "o", S*unit(l2));
te(3, 4, "c", 1.5W);
te(3, 5, "z", 1.5E);
te(4, 6, "k", W);
te(4, 7, "u", E);
te(6, 8, "a", W);
te(7, 9, "r", W);
te(5, 10, "a", W);
te(5, 11, "e", E);
te(11, 12, "l", W);
te(3, 13, "t", W);
te(13, 14, "e", W);
te(1, 15, "u", N*unit(r2));
te(15, 16, "z", W);
te(16, 17, "l", W);
te(17, 18, "e", W);
te(2, 19, "y", W);
te(19, 20, "s", W);
te(20, 21, "a", W);
te(20, 22, "k", E);
te(21, 23, "k", W);
te(22, 24, "a", E);

for (pair x: u)
	vertex(x, v_white);
for (int x: endings)
	vertex(x, v_black);
