import ads;

real u = 1;

pair v[] = {
	(0, 0) * u,
	(2, 1) * u,
	(4, 1) * u,
	(2, 0) * u,
	(4, 0) * u,
	(999, 999),
	(4, -1) * u,
	(6, -1) * u,
	(999, 999),
	(2, -1) * u,
};

labeled_graph(v);

arc(0, 1);
arc(0, 3);
arc(0, 9);
arc(1, 2);
arc(1, 3);
arc(3, 4);
arc(6, 3);
arc(6, 7);
arc(9, 6);

draw(v[6] + vertex_size*dir(225) {dir(225)} .. {dir(170)} (1.5, -1.7) * u .. {up} v[0] - vertex_size*up, e_arrow);

path lev = (0, -1.5)*u .. (-0.4, -1)*u {up} .. (-0.4, 0)*u .. {up} (-0.4, 1)*u .. (0, 1.5)*u .. (0.4, 1)*u {down} .. (0.4, 0)*u .. {down} (0.4, -1)*u .. cycle;
for (int i=0; i<4; ++i) {
	draw(shift(2u * i, 0) * lev, shortdashed);
	label("$V_" + (string) i + "$", (2i,1.9)*u);
}
