import ads;

pair v(real x, real y)
{
	return 0.5 * (x,y);
}

int n = 5;
for (int i=0; i<=n; ++i) {
	draw(v(i,0) -- v(i,n), hair);
	draw(v(0,i) -- v(n,i), hair);
}
draw(v(0,0)--v(0,n)--v(n,n)--v(n,0)--cycle, thick);
draw(v(1,0)--v(1,2), thick);
draw(v(1,3)--v(1,5), thick);
draw(v(1,3)--v(4,3)--v(4,1), thick);
draw(v(2,4)--v(5,4), thick);
draw(v(2,2)--v(3,2), thick);

transform t = shift(4, 0);
pair g[][] = identity(n);
for (int i=0; i<n; ++i) {
	for (int j=0; j<n; ++j) {
		g[i][j] = t * v(i+.5, j+.5);
		vertex(g[i][j]);
	}
}

pair hedges[] = {
	(1,0), (2,0), (3,0),
	(1,1), (2,1),
	(0,2), (1,2), (2,2),
	(1,3), (2,3), (3,3),
	(1,4), (2,4), (3,4),
};

pair vedges[] = {
	(0,0), (0,1), (0,2), (0,3),
	(1,0), (1,1), (1,3),
	(2,0),
	(3,0), (3,1),
	(4,0), (4,1), (4,2),
};

for (pair p: hedges) {
	int x = (int) p.x;
	int y = (int) p.y;
	edge(g[x][y], g[x+1][y]);
}

for (pair p: vedges) {
	int x = (int) p.x;
	int y = (int) p.y;
	edge(g[x][y], g[x][y+1]);
}
