import ads;

real u = 1;

pair v[] = {
	(0, 0) * u,
	(0.5, -1) * u,
	(-1, 1) * u,
};

graph(v);

label("$x$", v[0], NE);
label("$y$", v[1], NE);
label("$u$", v[2], NE);

draw(v[1] -- v[1] + dir(-120)*u -- v[1] + dir(-60)*u -- cycle);
label("$T_y$", v[1] + dir(-60)*u, NE);

edge(0, 1, halfthick);
edge(0, 2, dashed);

pair s = v[1] + dir(-90)*u/2;
pair t = (v[0]+v[2])/2;
draw(s {dir(170)} .. {dir(50)} t, shortdashed, e_arrow);
label("$s$", s, S);
label("$t$", t, NE);
