import ads;

/*** Graf ***/

pair v[];
for (int i=0; i<6; ++i)
	v[i] = 2*dir(60*(i+0.5));

vertex_size = 0.1;
graph(v, 1);

arc(0, 1);
arc(1, 5);
arc(2, 1);
arcd(2, 3, dir(-60), dir(240));
arcd(2, 4, dir(-40), dir(-80));
arc(2, 5);
arcd(3, 2, dir(120), dir(60));
arc(4, 5);
arc(5, 0);

real zz = 0.5;
draw(v[2] + (0,zz) .. v[2] + (zz,0) .. v[3] + (zz,0) .. v[3] - (0,zz) .. v[3] - (zz,0) .. v[2] - (zz,0) .. cycle, shortdashed);
draw(circle(v[4], zz), shortdashed);
draw(v[5] - (0,zz) .. tension 1.7 .. v[1] - (zz,0) .. v[1] + (0,zz) .. tension 1.2 .. v[0] + 1.2*zz*dir(45) .. tension 1.2 .. v[5] + (zz,0) .. cycle, shortdashed);

label("$C_1$", v[2], 5NW);
label("$C_2$", v[4], 5W);
label("$C_3$", v[5], 5SE);

/*** A jeho graf komponent ***/

pair gc = (4.5, 0);

pair w[] = {
	gc,
	gc + 1.5*dir(-50),
	gc + 2*dir(40),
};

vertex_size = 0.3;
graph(w, 1);

arc(0, 1);
arc(0, 2);
arc(1, 2);

label("$C_1$", w[0]);
label("$C_2$", w[1]);
label("$C_3$", w[2]);
