import ads;
import mst;

real u = 0.5;

pair ta = (0,2) * u;
pair tb = (0,0) * u;
pair tc = (0,-2) * u;
pair xa = (2,1) * u;
pair xb = (2,-1) * u;
pair z = (4,0) * u;

void me(pair x, pair y, int w)
{
	edge(x, y);
	mstlab((x+y)/2, w);
}

picture g = currentpicture;

picture g1 = ads_sub_pic();

me(ta, tb, 1);
me(tb, tc, 2);
me(ta, xa, 8);
me(tb, xa, 7);
me(tb, xb, 5);
me(tc, xb, 9);
me(xa, xb, 3);
me(xa, z, 4);
me(xb, z, 6);

vertex(ta);
vertex(tb);
vertex(tc);
vertex(xa);
vertex(xb);
vertex(z);

label("$v_0$", ta, 1.5 W);

picture g2 = ads_sub_pic();

edge(ta, tb, halfthick);
edge(tb, tc, halfthick);
edge(xa, ta, agray);
arc(xa, tb, agray);
arc(xb, tb, agray);
edge(xb, tc, agray);
edge(xa, xb, dotted);
edge(xa, z, dotted);
edge(xb, z, dotted);

vertex(ta);
vertex(tb);
vertex(tc);
vertex(xa, 2);
vertex(xb, 2);
vertex(z, 1);

label("\eightrm 7", xa, NE);
label("\eightrm 5", xb, SE);

picture g3 = ads_sub_pic();

edge(ta, tb, halfthick);
edge(tb, tc, halfthick);
edge(xa, ta, agray);
edge(xa, tb, agray);
edge(xb, tb, halfthick);
edge(xb, tc, dotted);
arc(xa, xb, agray);
edge(xa, z, dotted);
arc(z, xb, agray);

vertex(ta);
vertex(tb);
vertex(tc);
vertex(xa, 2);
vertex(xb);
vertex(z, 2);

label("\eightrm 3", xa, NE);
label("\eightrm 6", z, SE);

currentpicture = g;
add(centered(g1));
add(centered(g2), (3,0));
add(centered(g3), (6,0));
