/* Spolecne funkce pro kresleni minimalnich koster */

import ads;

int maxcol;
int maxrow;
int horiz_weights[][];
int vert_weights[][];
real mscale = 0.7;

void mst_running_example() {
	maxrow = 2;
	maxcol = 2;

	horiz_weights = new int [][] {
		{  1, 11 },
		{  5,  4 },
		{ 10,  6 },
	};

	vert_weights = new int [][] {
		{  0,  3,  9 },
		{  7,  8,  2 },
	};
}

pair v(real x, real y)
{
	return mscale * (x,y);
}

void mst_graph()
{
	for (int i=0; i<=maxcol; ++i) {
		for (int j=0; j<=maxrow; ++j) {
			vertex(v(i,j));
			if (i < maxcol) edge(v(i,j), v(i+1,j));
			if (j < maxrow) edge(v(i,j), v(i,j+1));
		}
	}
}

void mst_background(int vmode=0)
{
	for (int i=0; i<=maxcol; ++i) {
		for (int j=0; j<=maxrow; ++j) {
			vertex(v(i,j), vmode);
			if (i < maxcol) edge(v(i,j), v(i+1,j), finedotted);
			if (j < maxrow) edge(v(i,j), v(i,j+1), finedotted);
		}
	}
}

void mstlab(pair x, int w)
{
	draw("\eightrm " + (string) w, e=box, position=x, xmargin=0.01, ymargin=0.5, filltype=UnFill);
}

void mst_weights()
{
	for (int i=0; i<=maxcol; ++i) {
		for (int j=0; j<=maxrow; ++j) {
			if (i < maxcol) mstlab(v(i+0.5, j), horiz_weights[j][i]);
			if (j < maxrow) mstlab(v(i, j+0.5), vert_weights[j][i]);
		}
	}
}

void hmedge(int i, int j)
{
	edge(v(i,j), v(i+1, j), halfthick);
}

void vmedge(int i, int j)
{
	edge(v(i,j), v(i, j+1), halfthick);
}
