import ads;

/*
 *	Posloupnost unionu:
 *
 *		1 2
 *		4 5
 *		0 3
 *		0 1
 *		4 7
 *		4 6
 *		0 4
 *
 *	Vysledny graf:
 *
 *		2--1--0--3
 *		      |
 *		   5--4--7
 *		      |
 *		      6
 *
 *	Keriky:
 *
 *		1-----.
 *		|\     \
 *		2 3	4
 *		  |    /|\
 *		  0   6	5 7
 */

picture g = currentpicture;
picture g1 = ads_sub_pic();

real u = 1;

pair v[] = new pair[8];
v[0] = (0,0) * u;
v[1] = v[0] + dir(135)*u;
v[2] = v[1] - (1,0)*u;
v[3] = v[0] + dir(-135)*u;
v[4] = (1,0) * u;
v[5] = v[4] + dir(60)*u;
v[6] = v[4] + (1,0)*u;
v[7] = v[4] + dir(-60)*u;

labeled_graph(v);

edge(0, 1);
edge(0, 3);
edge(1, 2);
edge(0, 4);
edge(4, 5);
edge(4, 6);
edge(4, 7);

picture g2 = ads_sub_pic();

pair w[] = new pair[8];
w[1] = (0,0) * u;
w[2] = (-1.3,-1) * u;
w[3] = (1.3,-1) * u;
w[0] = w[3] + (0,-1)*u;
w[4] = (0,-1)*u;
w[5] = w[4] + (-0.5,-1)*u;
w[6] = w[4] + (0,-1)*u;
w[7] = w[4] + (0.5,-1)*u;

labeled_graph(w);

arc(2, 1);
arc(3, 1);
arc(0, 3);
arc(4, 1);
arc(5, 4);
arc(6, 4);
arc(7, 4);

currentpicture = g;
add(centered(g1));
add(centered(g2), (5.5,0));
