import ads;
import trees;

pair e = bst_edge;
pair le1 = rotate(-50) * e;
pair re1 = rotate(50) * e;
pair le2 = rotate(-22.5) * e;
pair re2 = rotate(22.5) * e;

/*** První strom ***/

pair u[];
u[0] = (0, 0);
u[1] = u[0] + le1;
u[2] = u[1] + le2;
u[3] = u[1] + re2;
u[4] = u[0] + re1;
u[5] = u[4] + le2;

tree_init(u);
tree_edge(0, 1);
tree_edge(0, 4);
tree_edge(1, 2);
tree_edge(1, 3);
tree_edge(4, 5);
tree_num(0, 7);
tree_num(1, 4);
tree_num(2, 2);
tree_num(3, 5);
tree_num(4, 9);
tree_num(5, 8);

/*** Druhý strom ***/

pair v[];
v[0] = (2.7, 0);
v[1] = v[0] + le1;
v[2] = v[0] + re1;
v[3] = v[2] + re1;
v[4] = v[3] + re1;
v[5] = v[4] + re1;

tree_init(v);
tree_edge(0, 1);
tree_edge(0, 2);
tree_edge(2, 3);
tree_edge(3, 4);
tree_edge(4, 5);
tree_num(0, 4);
tree_num(1, 2);
tree_num(2, 5);
tree_num(3, 7);
tree_num(4, 8);
tree_num(5, 9);

/*** Značení ***/

pair w[];
w[0] = (8, 0);
w[1] = w[0] + rotate(-35) * e;
w[2] = w[0] + rotate(35) * e;

tree_init(w);
tree_edge(0, 1);
tree_edge(0, 2);
tree_sub(1, "");
tree_sub(2, "");
tree_node(0, "v");
tree_node(1, "");
tree_node(2, "");

label("$\ell(v)$", w[1], 2.5*WNW);
label("$r(v)$", w[2], 2.5*ENE);
label("$L(v)$", w[1], 8*S);
label("$R(v)$", w[2], 8*S);

pair a = w[0] + (1.6, 0.3);
pair b = (w[0].x, w[2].y) + (1.6, -1);
draw(a -- a+(0.2,0) -- b+(0.2,0) -- b);
label("$h(v)$", point(a--b, 0.5) + (0.3,0), E);

pair c = w[1] + (-0.5, -1.6);
pair d = w[2] + (0.5, -1.6);
draw(c+(0,.1) -- c -- d -- d+(0,.1));
label("$T(v)$", point(c--d, 0.5), S);
