import ads;
import trees;

real u = 1;

pair e = bst_edge;
pair le = rotate(-45) * e;
pair re = rotate(45) * e;

pair um = bst_mini;
pair lm = rotate(135) * um;
pair rm = rotate(225) * um;

picture g = currentpicture;

/*** Nekorektní 3-vrchol ***/

pair v3[];
v3[0] = (0, 0);
v3[1] = v3[0] + re;
v3[2] = v3[0] + um;
v3[3] = v3[0] + lm;
v3[4] = v3[1] + lm;
v3[5] = v3[1] + rm;

picture g3 = ads_sub_pic();
tree_init(v3);
tree_edge(0, 1, rb_red);
tree_edge(0, 2, rb_black);
tree_edge(0, 3, rb_black);
tree_edge(1, 4, rb_black);
tree_edge(1, 5, rb_black);
tree_node(0, "x");
tree_node(1, "y");

/*** Nekorektní 4-vrchol jedním způsobem ***/

pair v4a[];
v4a[0] = (0, 0);
v4a[1] = v4a[0] + le;
v4a[2] = v4a[1] + le;
v4a[3] = v4a[0] + um;
v4a[4] = v4a[0] + rm;
v4a[5] = v4a[1] + rm;
v4a[6] = v4a[2] + lm;
v4a[7] = v4a[2] + rm;

picture g4a = ads_sub_pic();
tree_init(v4a);
tree_edge(0, 1, rb_red);
tree_edge(1, 2, rb_red);
tree_edge(0, 3, rb_black);
tree_edge(0, 4, rb_black);
tree_edge(1, 5, rb_black);
tree_edge(2, 6, rb_black);
tree_edge(2, 7, rb_black);
tree_node(0, "z");
tree_node(1, "y");
tree_node(2, "x");

/*** Nekorektní 4-vrchol jiným způsobem ***/

pair v4b[];
v4b[0] = (0, 0);
v4b[1] = v4b[0] + (2*le.x, le.y);
v4b[2] = v4b[1] + re;
v4b[3] = v4b[0] + um;
v4b[4] = v4b[0] + rm;
v4b[5] = v4b[1] + lm;
v4b[6] = v4b[2] + lm;
v4b[7] = v4b[2] + rm;

picture g4b = ads_sub_pic();
tree_init(v4b);
tree_edge(0, 1, rb_red);
tree_edge(1, 2, rb_red);
tree_edge(0, 3, rb_black);
tree_edge(0, 4, rb_black);
tree_edge(1, 5, rb_black);
tree_edge(2, 6, rb_black);
tree_edge(2, 7, rb_black);
tree_node(0, "z");
tree_node(1, "x");
tree_node(2, "y");

/*** Celek ***/

currentpicture = g;
add(centered(g3), (0, 0) * u);
add(centered(g4a), (3, 0) * u);
add(centered(g4b), (6.5, 0) * u);
