import ads;
import trees;

real u = 1;
pair e = bst_edge;
pair mini = bst_mini;

/*** Počáteční stav ***/

pair v[];
v[0] = (0, 0) * u;			// v
v[1] = v[0] + rotate(-45) * e;		// t
v[2] = v[0] + rotate(45) * e;		// y
v[3] = v[1] + rotate(-30) * e;		// s
v[4] = v[1] + rotate(225) * mini;
v[5] = v[2] + rotate(135) * mini;
v[6] = v[2] + rotate(225) * mini;
v[7] = v[3] + rotate(135) * mini;
v[8] = v[3] + rotate(225) * mini;
v[9] = v[0] + mini;

tree_init(v);
tree_edge(0, 1, rb_red);
tree_edge(0, 2, rb_red);
tree_edge(0, 9, rb_black);
tree_edge(1, 3, rb_red);
tree_edge(1, 4, rb_black);
tree_edge(2, 5, rb_black);
tree_edge(2, 6, rb_black);
tree_edge(3, 7, rb_black);
tree_edge(3, 8, rb_black);
tree_node(0, "v");
tree_node(1, "t");
tree_node(2, "y");
tree_node(3, "s");

/*** Po první rotaci ***/

pair w[];
w[0] = (3.5, 0) * u;			// t
w[1] = w[0] + rotate(-45) * e;		// s
w[2] = w[0] + rotate(45) * e;		// v
w[3] = w[2] + rotate(30) * e;		// y
w[4] = w[1] + rotate(135) * mini;
w[5] = w[1] + rotate(225) * mini;
w[6] = w[2] + rotate(135) * mini;
w[7] = w[3] + rotate(135) * mini;
w[8] = w[3] + rotate(225) * mini;
w[9] = w[0] + mini;

tree_init(w);
tree_edge(0, 1, rb_red);
tree_edge(0, 2, rb_red);
tree_edge(0, 9, rb_black);
tree_edge(1, 4, rb_black);
tree_edge(1, 5, rb_black);
tree_edge(2, 6, rb_black);
tree_edge(3, 2, rb_red);
tree_edge(3, 7, rb_black);
tree_edge(3, 8, rb_black);
tree_node(0, "t");
tree_node(1, "s");
tree_node(2, "v");
tree_node(3, "y");

/*** A nakonec přebarvení ***/

pair x[];
for (int i=0; i < w.length; ++i) {
	x[i] = w[i] + (3.5, 0) * u;
}

tree_init(x);
tree_edge(0, 1, rb_black);
tree_edge(0, 2, rb_black);
tree_edge(0, 9, rb_red);
tree_edge(1, 4, rb_black);
tree_edge(1, 5, rb_black);
tree_edge(2, 6, rb_black);
tree_edge(3, 2, rb_red);
tree_edge(3, 7, rb_black);
tree_edge(3, 8, rb_black);
tree_node(0, "t");
tree_node(1, "s");
tree_node(2, "v");
tree_node(3, "y");

/*** Šipky ***/

void ar(pair p, pair q)
{
	pair c = 0.5(p+q);
	draw(c-(0.5,0)*u -- c+(0.5,0)*u, e_arrow);
}

ar(v[0], w[0]);
ar(w[0], x[0]);
