import ads;
import trees;

real u = 1;
pair e = bst_edge;
pair mini = bst_mini;

/*** Počáteční stav ***/

pair v[];
v[0] = (0, 0) * u;			// v
v[1] = v[0] + rotate(-45) * e;		// t
v[2] = v[0] + rotate(45) * e;		// y
v[3] = v[2] + rotate(-30) * e;		// x
v[4] = v[1] + rotate(135) * mini;
v[5] = v[1] + rotate(225) * mini;
v[6] = v[2] + rotate(225) * mini;
v[7] = v[3] + rotate(135) * mini;
v[8] = v[3] + rotate(225) * mini;
v[9] = v[0] + mini;

tree_init(v);
tree_edge(0, 1, rb_red);
tree_edge(0, 2, rb_red);
tree_edge(0, 9, rb_black);
tree_edge(1, 4, rb_black);
tree_edge(1, 5, rb_black);
tree_edge(2, 3, rb_red);
tree_edge(2, 6, rb_black);
tree_edge(3, 7, rb_black);
tree_edge(3, 8, rb_black);
tree_node(0, "v");
tree_node(1, "t");
tree_node(2, "y");
tree_node(3, "x");

/*** Po první rotaci ***/

pair w[];
w[0] = (2.9, 0) * u;			// v
w[1] = w[0] + rotate(-45) * e;		// t
w[2] = w[0] + rotate(45) * e;		// x
w[3] = w[2] + rotate(30) * e;		// y
w[4] = w[1] + rotate(135) * mini;
w[5] = w[1] + rotate(225) * mini;
w[6] = w[2] + rotate(135) * mini;
w[7] = w[3] + rotate(135) * mini;
w[8] = w[3] + rotate(225) * mini;
w[9] = w[0] + mini;

tree_init(w);
tree_edge(0, 1, rb_red);
tree_edge(0, 2, rb_red);
tree_edge(0, 9, rb_black);
tree_edge(1, 4, rb_black);
tree_edge(1, 5, rb_black);
tree_edge(2, 6, rb_black);
tree_edge(3, 2, rb_red);
tree_edge(3, 7, rb_black);
tree_edge(3, 8, rb_black);
tree_node(0, "v");
tree_node(1, "t");
tree_node(2, "x");
tree_node(3, "y");

/*** Po druhé rotaci ***/

pair x[];
x[0] = (6.8, 0) * u;			// x
x[1] = x[0] + rotate(-45) * e;		// v
x[2] = x[0] + rotate(45) * e;		// y
x[3] = x[1] + rotate(-30) * e;		// t
x[4] = x[1] + rotate(225) * mini;
x[5] = x[2] + rotate(225) * mini;
x[6] = x[2] + rotate(135) * mini;
x[7] = x[3] + rotate(225) * mini;
x[8] = x[3] + rotate(135) * mini;
x[9] = x[0] + mini;

tree_init(x);
tree_edge(0, 1, rb_red);
tree_edge(0, 2, rb_red);
tree_edge(0, 9, rb_black);
tree_edge(1, 3, rb_red);
tree_edge(1, 4, rb_black);
tree_edge(2, 5, rb_black);
tree_edge(2, 6, rb_black);
tree_edge(3, 7, rb_black);
tree_edge(3, 8, rb_black);
tree_node(0, "x");
tree_node(1, "v");
tree_node(2, "y");
tree_node(3, "t");

/*** A nakonec přebarvení ***/

pair y[];
for (int i=0; i < x.length; ++i) {
	y[i] = x[i] + (3, 0) * u;
}

tree_init(y);
tree_edge(0, 1, rb_black);
tree_edge(0, 2, rb_black);
tree_edge(0, 9, rb_red);
tree_edge(1, 3, rb_red);
tree_edge(1, 4, rb_black);
tree_edge(2, 5, rb_black);
tree_edge(2, 6, rb_black);
tree_edge(3, 7, rb_black);
tree_edge(3, 8, rb_black);
tree_node(0, "x");
tree_node(1, "v");
tree_node(2, "y");
tree_node(3, "t");

/*** Šipky ***/

void ar(pair p, pair q)
{
	pair c = 0.5(p+q);
	draw(c-(0.5,0)*u -- c+(0.5,0)*u, e_arrow);
}

ar(v[0], w[0]);
ar(w[0], x[0]);
ar(x[0], y[0]);
