import ads;
import trees;

/*** (a,b)-strom ***/

pair u[];
real s = 1;
u[0] = (0,0);
u[1] = u[0] + (-1.8, -s);
u[2] = u[0] + (-0.6, -s);
u[3] = u[0] + (0.6, -s);
u[4] = u[0] + (1.8, -s);
// Externí:
u[5] = u[1] + (-0.25, -s);
u[6] = u[1] + (0.25, -s);
u[7] = u[2] + (-0.4, -s);
u[8] = u[2] + (0, -s);
u[9] = u[2] + (0.4, -s);
u[10] = u[3] + (-0.22, -s);
u[11] = u[3] + (0.25, -s);
u[12] = u[4] + (-0.45, -s);
u[13] = u[4] + (-0.15, -s);
u[14] = u[4] + (0.15, -s);
u[15] = u[4] + (0.45, -s);

tree_init(u);

real d = 0.1;
real d1 = 0.1;
real d2 = 0.3;
ab_edge(0, 1, -d2);
ab_edge(0, 2, -d1);
ab_edge(0, 3, d1);
ab_edge(0, 4, d2);
ab_edge(1, 5, -d);
ab_edge(1, 6, d);
ab_edge(2, 7, -d);
ab_edge(2, 8, 0);
ab_edge(2, 9, d);
ab_edge(3, 10, -d);
ab_edge(3, 11, d);
ab_edge(4, 12, -d2);
ab_edge(4, 13, -d1);
ab_edge(4, 14, d1);
ab_edge(4, 15, d2);

tree_elliptic_node(0, "1\;4\;6", elong=1.5);
tree_elliptic_node(1, "0", elong=1.5);
tree_elliptic_node(2, "2\;3", elong=1.5);
tree_elliptic_node(3, "5", elong=1.5);
tree_elliptic_node(4, "7\;8\;9", elong=1.5);
for (int i=5; i<=15; ++i)
	tree_ext(i);

/*** Jeho překlad na LLRB ***/

pair e = bst_edge;
pair mini = bst_mini;
pair le = rotate(-65) * e * 1.5;
pair re = rotate(65) * e * 1.5;
pair le2 = rotate(-45) * e;
pair re2 = rotate(45) * e;
pair le3 = rotate(-26) * e * 0.7;
pair re3 = rotate(26) * e * 0.7;
pair le4 = rotate(-12) * e * 0.7;
pair re4 = rotate(12) * e * 0.7;

pair v[];
v[0] = (6,0);
v[1] = v[0] + le;
v[2] = v[0] + re;
v[3] = v[1] + le2;
v[4] = v[1] + re2;
v[5] = v[2] + le2;
v[6] = v[2] + re2;
v[7] = v[4] + le3;
v[8] = v[6] + le3;
v[9] = v[6] + re3;
// Externí:
v[10] = v[3] + le3;
v[11] = v[3] + re3;
v[12] = v[4] + re3;
v[13] = v[5] + le3;
v[14] = v[5] + re3;
v[15] = v[7] + le4;
v[16] = v[7] + re4;
v[17] = v[8] + le4;
v[18] = v[8] + re4;
v[19] = v[9] + le4;
v[20] = v[9] + re4;

tree_init(v);

tree_edge(0, 1, rb_red);
tree_edge(0, 2, rb_red);
tree_edge(1, 3, rb_black);
tree_edge(1, 4, rb_black);
tree_edge(2, 5, rb_black);
tree_edge(2, 6, rb_black);
tree_edge(4, 7, rb_red);
tree_edge(6, 8, rb_red);
tree_edge(6, 9, rb_red);
// Externí:
tree_edge(3, 10, rb_black);
tree_edge(3, 11, rb_black);
tree_edge(4, 12, rb_black);
tree_edge(5, 13, rb_black);
tree_edge(5, 14, rb_black);
tree_edge(7, 15, rb_black);
tree_edge(7, 16, rb_black);
tree_edge(8, 17, rb_black);
tree_edge(8, 18, rb_black);
tree_edge(9, 19, rb_black);
tree_edge(9, 20, rb_black);

tree_label_offset = (0, -0.02);

tree_node(0, "4");
tree_node(1, "1");
tree_node(2, "6");
tree_node(3, "0");

tree_node(0, "4");
tree_node(1, "1");
tree_node(2, "6");
tree_node(3, "0");
tree_node(4, "3");
tree_node(5, "5");
tree_node(6, "8");
tree_node(7, "2");
tree_node(8, "7");
tree_node(9, "9");
for (int i=10; i<=20; ++i)
	tree_ext(i);
