import ads;

int n = 65;
real xscale = 0.2;
real yscale = 0.5;

int pot(int x)
{
	int p = 0;
	while (x > 0) {
		if (x%2 == 1)
			++p;
		x = quotient(x, 2);
	}
	return p;
}

int work(int x)
{
	int p = 1;
	while (x%2 == 1) {
		++p;
		x = quotient(x, 2);
	}
	return p;
}

string tobin(int x, int dig)
{
	string s = "";
	for (int i=0; i<dig; ++i) {
		s = (string)(x%2) + s;
		x = quotient(x, 2);
	}
	return s;
}

real ht = 0;
for (int i=1; i<n; ++i) {
	fill(box((xscale*(i-0.4), 0), (xscale*(i+0.4), work(i-1)*yscale)), agray);
}

pair prev;
for (int i=0; i<n; ++i) {
	pair t = (xscale*i, pot(i)*yscale);
	if (i > 0)
		draw(prev -- t, thin);
	fill(circle(t, 0.05));
	label(rotate(90) * ("\seventt " + tobin(i,7)), (xscale*i, -0.7));
	prev = t;
}
