import ads;
import trees;

// Strom

real spread = 1;
pair t[] = complete_binary_tree(2.5, spread, 3);
tree_init(t);
vertex_size = 0.07;

for (int i=2; i<=7; ++i)
	tree_edge(i, (int)(i/2));

for (int i=4; i<=7; ++i) {
	for (int j=0; j<2; ++j) {
		pair d = dir(-90 + 45*(j-0.5)) * 0.3;
		draw(t[i] -- t[i]+d);
	}
}

for (int i=1; i<=7; ++i)
	tree_node(i);

for (int i=0; i<=6; ++i) {
	pair p = t[4] - (0.4,spread) + (vertex_size*4,0)*i;
	pair q = t[7] + (0.4,-spread) - (vertex_size*4,0)*i;
	if (i < 6) {
		vertex(p, v_white);
		vertex(q, v_white);
	} else {
		draw(p -- q, shortdashed);
	}
}

// Vrstvy

for (int i=0; i<4; ++i) {
	pair p = (-4,0) - (0,spread)*(i-0.5);
	pair q = (6.4,0) - (0,spread)*(i-0.5);
	draw(p -- q, shortdashed);
}

// Tabulka

pair cols[] = {
	t[1] + (-3.5,0),
	t[1] + (3.5,0),
	t[1] + (4.7,0),
	t[1] + (5.9,0),
};

pair headrow = (0,0.8spread);
texpreamble("\font\hhh=csr8\def\hh{\hhh\vrule width 0pt depth 3pt}");
label("\hh hladina", cols[0] + headrow);
label("\hh vrcholů", cols[1] + headrow);
label("\hh velikost", cols[2] + headrow);
label("\hh celkem", cols[3] + headrow);

for (int i=0; i<3; ++i) {
	pair row = (0,-spread*i);
	label("\strut $" + (string)i + "$", cols[0] + row);
	label("\strut $" + (string)(2**i) + "$", cols[1] + row);
	label("\strut $N/" + (string)(2**i) + "$", cols[2] + row);
	label("\strut $N$", cols[3] + row);
}

pair lastrow = (0,-spread*3);
label("\strut $\log_2 N$", cols[0] + lastrow);
label("\strut $N$", cols[1] + lastrow);
label("\strut $1$", cols[2] + lastrow);
label("\strut $N$", cols[3] + lastrow);
