import ads;

string p[] = new string[] { "p", "o", "u", "t", "n", "í", "k" };
string q[] = new string[] { "p", "o", "t", "e", "m", "n", "í", "k" };
int m = p.length;
int n = q.length;

pair g(real i, real j)
{
	return (i*0.7, -j*0.7);
}

draw(g(0,0) -- g(1,1) -- g(2,2) -- g(3,3) -- g(3,4) -- g(4,5) -- g(5,6) -- g(6,7) -- g(7,8), agray + 2mm);

for (int i=0; i<=m; ++i) {
	for (int j=0; j<=n; ++j) {
		if (i > 0)
			arc(g(i-1,j), g(i,j), shortdashed, e_miniarrow);
		if (j > 0)
			arc(g(i,j-1), g(i,j), shortdashed, e_miniarrow);
		if (i > 0 && j > 0) {
			if (p[i-1] == q[j-1])
				arc(g(i-1,j-1), g(i,j), halfthick, e_miniarrow);
			else
				arc(g(i-1,j-1), g(i,j), shortdashed, e_miniarrow);
		}
	}
}

for (int i=0; i<=m; ++i) {
	for (int j=0; j<=n; ++j) {
		vertex(g(i,j), v_white);
	}
}

for (int i=0; i<m; ++i) {
	label("{\tt\strut " + p[i] + "}", g(i+0.5,0), 2N);
}
for (int j=0; j<n; ++j) {
	label("{\tt\strut " + q[j] + "}", g(0,j+0.5), 2.5W);
}
