import ads;
import trees;

pair l1 = (-2, -1);
pair r1 = (2, -1);
pair l2 = (-1, -1);
pair r2 = (1, -1);
pair l3 = (-0.5, -1);
pair r3 = (0.5, -1);
pair l4 = (-0.5, -1);
pair r4 = (0.5, -1);

pair v[];
v[0] = (0,0);
v[1] = v[0] + l1;
v[2] = v[0] + r1;
v[3] = v[1] + l2;
v[4] = v[1] + r2;
v[5] = v[2] + l2;
v[6] = v[2] + r2;
v[7] = v[3] + l3;
v[8] = v[3] + r3;
v[9] = v[4] + l3;
v[10] = v[4] + r3;
v[11] = v[5] + l3;
v[12] = v[5] + r3;
v[13] = v[7] + l4;
v[14] = v[7] + r4;
tree_node_size = 0.25;
tree_init(v);

pen s = middashed + agray;
tree_edge(0, 1);
tree_edge(0, 2);
tree_edge(1, 3);
tree_edge(1, 4);
tree_edge(2, 5, s);
tree_edge(2, 6, s);
tree_edge(3, 7);
tree_edge(3, 8);
tree_edge(4, 9, s);
tree_edge(4, 10, s);
tree_edge(5, 11, s);
tree_edge(5, 12, s);
tree_edge(7, 13);
tree_edge(7, 14);

int fib[] = new int[] { 0, 1, 1, 2, 3, 5 };

void f(int i, int k)
{
	tree_node(i, "F_" + (string) k);
	label("$" + (string) fib[k] + "$", v[i] + (0, 0.5));
}

void g(int i, int k)
{
	tree_node(i, v_shadow);
}

f(0, 5);
f(1, 4);
f(2, 3);
f(3, 3);
f(4, 2);
g(5, 2);
g(6, 1);
f(7, 2);
f(8, 1);
g(9, 1);
g(10, 0);
g(11, 1);
g(12, 0);
f(13, 1);
f(14, 0);
