import ads;
vertex_size = 0.2;

int p[] = new int[] { 0, 1, 13, 7, 15, 10, 19 };
int n = p.length;
real scale = 1.2;

pair v(int i)
{
	return (1.2*i, 0.33*p[i]) * scale;
}

int z[] = new int[] { 0, 1, 3, 4, 6 };
for (int i=1; i<z.length; ++i) {
	draw(v(z[i-1]) -- v(z[i]), agray + 1mm);
}

for (int i=0; i<n; ++i) {
	pair z = (-2, 0.33*p[i]) * scale;
	draw(v(i) -- z, shortdashed);
	if (p[i] == 0) {
		label("$-\infty$", z, W);
	} else if (p[i] == 19) {
		label("$+\infty$", z, W);
	} else {
		string pad = "";
		label("$" + pad + (string) p[i] + "$", z, W);
	}
}

for (int i=0; i<n; ++i) {
	for (int j=i+1; j<n; ++j) {
		if (p[i] < p[j])
			arc(v(i), v(j), e_smallarrow);
	}
}

for (int i=0; i<n; ++i) {
	vertex(v(i), v_white);
	label("\ninerm " + (string) i, v(i));
}
