import ads;
import trees;

// Internal node
tnode t(tnode parent, real rangle, string lab, pair lpos=(0,0), real mid=0.5)
{
	tnode v = tn_add(parent, rangle);
	lab = '\\tt ' + replace(lab, '$', '\\$');
	v.draw_vertex = new void (tnode w) {
		vertex(w.id, mode=(w.sons.length > 0 ? v_white : v_black));
	};
	v.draw_edge = new void (tnode w) {
		if (w.parent != null) {
			tree_edge(w.parent.id, w.id);
			label(lab, interp(w.parent.pos, w.pos, mid), lpos);
		}
	};
	return v;
}

tree_node_size = 0.1;
tn_edge_len = 2;
tn_init();

tnode r = t(null, 0, "");
t(r, -70, '$', NW);
tnode aroko = t(r, -55, 'aroko', 1.5NW, 1);
tn_edge_len = 1.5;
tnode bb = t(r, -30, 'barokoarokoko$', 2S, 1);
tn_edge_len = 2;
tnode ko = t(r, 20, 'ko', E);
tnode o = t(r, 60, 'o', SW);
tnode roko = t(r, 73, 'roko', NE);
t(aroko, -15, 'arokoko$', NW, 0.7);
t(aroko, 15, 'ko$', NE, 0.7);
t(ko, -25, '$', NW, 0.7);
t(ko, 0, 'arokoko$', 2S, 1);
t(ko, 25, 'ko$', NE, 0.7);
t(o, -25, '$', NW, 0.3);
t(o, -5, 'arokoko$', 2S, 1);
tnode oko = t(o, 30, 'ko', NE, 0.3);
t(oko, -30, '$', NW, 0.7);
t(oko, 0, 'arokoko$', 2S, 1);
t(oko, 30, 'ko$', NE, 0.7);
t(roko, -15, 'arokoko$', NW, 0.7);
t(roko, 15, 'ko$', NE, 0.7);

tn_draw();
