#!/usr/bin/python3

def lcp(x, y):
    i = 0
    while i < len(x) and i < len(y) and x[i] == y[i]:
        i += 1
    return i

w = 'barokoarokoko'
n = len(w)

suff = sorted(w[i:] for i in range(n+1))
s = [n - len(suff[i]) for i in range(n+1)]
l = [lcp(suff[i], suff[i+1]) for i in range(n)]

r = [0]*(n+1)
for i in range(n+1):
    r[s[i]] = i

for i in range(n+1):
    sf = suff[i]
    if i < n:
        lcp = l[i]
        if i == 0:
            sf = r'\varepsilon'
        else:
            sf = r'\a{%s}{%s}' % (sf[:lcp], sf[lcp:])
    else:
        sf = r'\a{}{%s}' % (sf,)
        lcp = '--'
    print(f'{i}\t& {s[i]}\t& {r[i]}\t& {lcp}\t& {sf} \\cr')
