import ads;
unitsize(1.1cm);

pair l(int i) {
	return (0, 2-i);
}

pair r(int i) {
	return (2, 2-i);
}

pair z = (-2, 0);
pair s = (4, 0);

pair v[] = {
	z, s,
	l(0), l(1), l(2), l(3), l(4),
	r(0), r(1), r(2), r(3), r(4),
};

vertex_size = 0.08;
graph(v);
label("$z$", z, 1.5W);
label("$s$", s, 1.5E);

/*
// Pro kontrolu: minimální vrcholové pokrytí
vertex(l(1), 1);
vertex(r(1), 1);
vertex(r(2), 1);
vertex(l(3), 1);
*/

edge(z, l(0), thick);
edge(z, l(1), thick);
edge(z, l(2));
edge(z, l(3), thick);
edge(z, l(4), thick);

edge(r(0), s, thick);
edge(r(1), s, thick);
edge(r(2), s, thick);
edge(r(3), s);
edge(r(4), s, thick);

edge(l(0), r(1), thick);
edge(l(0), r(2));
edge(l(1), r(0), thick);
edge(l(1), r(1));
edge(l(1), r(2));
edge(l(1), r(3));
edge(l(2), r(1));
edge(l(2), r(2));
edge(l(3), r(2));
edge(l(3), r(3));
edge(l(3), r(4), thick);
edge(l(4), r(2), thick);
