import ads;

picture g = currentpicture;

pair z = (-2, 0);
pair lu = (-1, 1);
pair ld = (-1, -1);
pair ru = (1, 1);
pair rd = (1, -1);
pair s = (2, 0);

picture graf = ads_sub_pic();
vertex(z);	label("$z$", z, W);
vertex(lu);	label("$a$", lu, 1.2*NNW);
vertex(ld);	label("$b$", ld, 1.2*SSW);
vertex(ru);	label("$c$", ru, 1.2*NNE);
vertex(rd);	label("$d$", rd, 1.2*SSE);
vertex(s);	label("$s$", s, E);
arc(z, lu, e_smallarrow);
arc(z, ld, e_smallarrow);
arc(lu, ru, e_smallarrow);
arc(lu, rd, e_smallarrow);
arc(ld, ru, e_smallarrow);
arc(ld, rd, e_smallarrow);
arc(ru, s, e_smallarrow);
arc(rd, s, e_smallarrow);

picture sit = ads_sub_pic();
add(graf);
label("$10$", .5(z+lu), NW);
label("$10$", .5(z+ld), SW);
label("$7$", .5(lu+ru), N);
label("$5$", interp(lu, rd, .75), NE);
label("$9$", interp(ld, ru, .25), NW);
label("$3$", .5(ld+rd), S);
label("$10$", .5(ru+s), NE);
label("$10$", .5(rd+s), SE);

picture tok = ads_sub_pic();
add(graf);
label("$10$", .5(z+lu), NW);
label("$6$", .5(z+ld), SW);
label("$6$", .5(lu+ru), N);
label("$4$", interp(lu, rd, .75), NE);
label("$3$", interp(ld, ru, .25), NW);
label("$3$", .5(ld+rd), S);
label("$9$", .5(ru+s), NE);
label("$7$", .5(rd+s), SE);

currentpicture = g;
add(centered(sit), (0,0));
add(centered(tok), (5,0));
