import ads;

path boxcut(path p, path bbox)
{
	slice i1 = firstcut(p, bbox);
	slice i2 = lastcut(i1.after, bbox);
	return i2.before;
}

path parabola(pair c, real a, path bbox, real d=0.1)
{
	guide g;
	for (real x=-1; x<11; x+=d) {
		real y = -a*((x-c.x)^2) + c.y;
		if (y >= -100 && y < 100)
			g = g .. (x,y);
	}
	return boxcut(g, bbox);
}
