import ads;

pair A[];
pair sh;

// det(M) > 0
A[0] = (-2, 0);
A[1] = (0, -1);
A[2] = (1.5, 0);
A[3] = A[0] + A[2] - A[1];
fill(A[0] -- A[1] -- A[2] -- A[3] -- cycle, area_gray);
draw(A[0] -- A[1] -- A[2] -- A[3] -- cycle, middashed);
draw(A[0] -- interp(A[0], A[1], 0.96), thick, e_smallarrow);
draw(A[1] -- interp(A[1], A[2], 0.96), thick, e_smallarrow);
for (int i=0; i<=2; ++i)
	fpoint(A[i]);
label("$h_{k-1}$", A[0], W);
label("$h_k$", A[1], S);
label("$b$", A[2], E);
label("$\bf u$", interp(A[0], A[1], 0.5), 1.2SW);
label("$\bf v$", interp(A[1], A[2], 0.5), 1.2SE);
label("$\det(M) > 0$", interp(A[0], A[2], 0.5));

// det(M) = 0
sh = (4, 1);
A[0] = (-1, -0.5) + sh;
A[1] = (0, -1) + sh;
A[2] = (1, -1.5) + sh;
draw(A[0] -- interp(A[0], A[1], 0.96), thick, e_smallarrow);
draw(A[1] -- interp(A[1], A[2], 0.96), thick, e_smallarrow);
for (int i=0; i<=2; ++i)
	fpoint(A[i]);
label("$h_{k-1}$", A[0], W);
label("$h_k$", A[1], 1.2S);
label("$b$", A[2], E);
label("$\bf u$", interp(A[0], A[1], 0.4), 1.2SW);
label("$\bf v$", interp(A[1], A[2], 0.6), 1.2SW);
label(rotate(-28) * Label("$\det(M) = 0$"), A[1], dir(90-28)*0.9);

// det(M) < 0
sh = (7, 1.25);
A[0] = (-1, -0.5) + sh;
A[1] = (1.5, -1) + sh;
A[2] = (2, -2.5) + sh;
A[3] = A[0] + A[2] - A[1];
fill(A[0] -- A[1] -- A[2] -- A[3] -- cycle, area_gray);
draw(A[0] -- A[1] -- A[2] -- A[3] -- cycle, middashed);
draw(A[0] -- interp(A[0], A[1], 0.96), thick, e_smallarrow);
draw(A[1] -- interp(A[1], A[2], 0.96), thick, e_smallarrow);
for (int i=0; i<=2; ++i)
	fpoint(A[i]);
label("$h_{k-1}$", A[0], W);
label("$h_k$", A[1], NE);
label("$b$", A[2], E);
label("$\bf u$", interp(A[0], A[1], 0.5), N);
label("$\bf v$", interp(A[1], A[2], 0.5), E);
label("$\det(M) < 0$", interp(A[0], A[2], 0.5));

/*
	% det(M) < 0
	shift := (7.5cm, 1.25cm);
	A[0] := (-1cm, -0.5cm) + shift;
	A[1] := (1.5cm, -1cm) + shift;
	A[2] := (2cm, -2.5cm) + shift;
	A[3] := A[0] + A[2] - A[1];
	fill A[0]--A[1]--A[2]--A[3]--cycle withcolor 0.8white;
	draw A[0]--A[1]--A[2]--A[3]--cycle dashed evenly;
	drawarrow A[0]--0.96[A[0],A[1]] withpen boldpen;
	drawarrow A[1]--0.96[A[1],A[2]] withpen boldpen;
	for i:=0 upto 2: draw vertex(A[i]); endfor
	label.lft(btex $h_{k-1}$ etex, A[0]);
	label.urt(btex $h_k$ etex, A[1]);
	label.top(btex $\vec u$ etex, 0.5[A[0],A[1]]);
	label.rt(btex $\vec v$ etex, 0.5[A[1],A[2]]);
	label.rt(btex $b$ etex, A[2]);
	label(btex $\det(M) < 0$ etex, 0.5[A[0],A[2]]);

*/
