import ads;
import trees;
unitsize(1.2cm);

tree_node_size = vertex_size;
tn_edge_len = 0.7;

void t(int parent_id, real angle)
{
	tnode n = tn_add(parent_id, angle);
	n.mode = v_black;
}

tn_init();
t(-1, 0);		// 0 = kořen
t(0, -67);		// 1
t(0, -45);		// 2
t(0, 45);		// 3
t(0, 67);		// 4
t(2, 0);		// 5
tn_draw();

draw(tn_pos[3] -- tn_pos[3] + (-0.25,-1) -- tn_pos[3] + (0.25,-1) -- cycle);
draw(tn_pos[4] -- tn_pos[4] + (-0.4,-1.2) -- tn_pos[4] + (0.4,-1.2) -- cycle);

pair low = (0, -1.6);
label("\tenrm řád $k$", tn_pos[0], 2N);
label("\tenrm řád $0$", tn_pos[1] + low);
label("\tenrm řád $1$", tn_pos[2] + low);
//label("\tenrm řád $k-2$", tn_pos[3] + low);
label("\tenrm řád $k-1$", tn_pos[4] + low);
label("$\ldots$", interp(tn_pos[2], tn_pos[3], 0.5) + 0.2*low);
