import ads;

pair v[];
current_graph = v;
vertex_size = 0.2;
real tri_size = 0.5;
real var_edge = 0.8;
real var_dist = 1;
pair var_top = (0, var_edge*1.5 + var_dist);

void triangle(pair c, real a)
{
	int i = v.length;
	v.push(c + tri_size*dir(a));
	v.push(c + tri_size*dir(a + 120));
	v.push(c + tri_size*dir(a - 120));
	vertex(i, v_white);
	vertex(i+1, v_white);
	vertex(i+2, v_white);
	edge(i, i+1);
	edge(i, i+2);
	edge(i+1, i+2);
}

// vertices 0, 1, 2
triangle((-2, 0), 0);

label("\eightrm N", v[0]);
label("\tenrm 1", v[1]);
label("\tenrm 0", v[2]);

// vertices 3,4 5,6 7,8
for (int i=0; i<3; ++i) {
	pair z = var_top + i*(var_edge + var_dist)*S;
	int j = v.length;
	v.push(z);
	v.push(z - (0, var_edge));
	vertex(j, v_white);
	vertex(j+1, v_white);
	edge(j, j+1);
	string var = format("%c", ascii("x") + i);
	label("\strut $" + var + "$", v[j]);
	label("\strut $\overline " + var + "$", v[j+1]);
}

// 9, 10, 11
triangle(v[6] + (2.5, -0) - tri_size*dir(-120), 0);

// 12, 13, 14
triangle(v[9] + (1.2, 0) - tri_size*dir(120), 0);

for (int i=0; i<6; ++i)
	edge(0, 3+i);

edged(3, 10, dir(0), dir(-30));
edge(6, 11);
edged(7, 14, dir(0), dir(30));

edge(9, 13);

draw(
	v[2] + vertex_size*dir(-135) {dir(-135)} ..
	v[2] - (0, 2) ..
	tension 2 ..
	v[12] - (0, 2) ..
	{dir(135)} v[12] - vertex_size*dir(135)
);

label("$x \lor \lnot y \lor z$", (4, 1));
