import ads;
import tdp;

pair d2 = (-1,-1);
pair k2 = rotate(90) * d2;
pair d1 = rotate(180) * d2;
pair k1 = rotate(270) * d2;

pair z4 = (0,-2.3);
pair z3 = rotate(90) * z4;
pair z2 = rotate(180) * z4;
pair z1 = rotate(270) * z4;

pair D = (0,-1.5);
pair C = rotate(90) * D;
pair B = rotate(180) * D;
pair A = rotate(270) * D;

triple(A, 90, d2, k1, z1, white, thin);
triple(B, 0, k1, d1, z2, white, thin);
triple(C, 270, d1, k2, z3, white, thin);
triple(D, 180, k2, d2, z4, white, thin);

label("$\bf A$", A, 3E);
label("$\bf B$", B, 3S);
label("$\bf C$", C, 3W);
label("$\bf D$", D, 3N);

void v(pair p, string s)
{
	unfill(circle(p, 0.3));
	label("$" + s + "$", p);
}

v(d1, "d_1");
v(d2, "d_2");
v(k1, "k_1");
v(k2, "k_2");

v(z1, "z_1");
v(z2, "z_2");
v(z3, "z_3");
v(z4, "z_4");
