import ads;

/*** Gadgety pro rovnice ***/

picture g = currentpicture;

picture a = ads_sub_pic();

real gh = 0.7;
real h = 5;
pair v[];

int nl = 4;
real dl = (h - nl*gh) / (nl-1);
for (int i=0; i<nl; ++i) {
	real y = i*(gh+dl);
	v.push((0, y));
	v.push((0, y+gh));
}

int right = 2*nl;
int nr = 3;
real dr = (h - nr*gh) / (nr-1);
for (int i=0; i<nr; ++i) {
	real y = i*(gh+dr);
	v.push((2, y));
	v.push((2, y+gh));
}

void pp(int i)
{
	i = 2*i;
	edged(i, i+1, dir(135), dir(45));
	edged(i, i+1, dir(45), dir(135));
}

void tt(int i)
{
	i = 2*i;
	edged(i, i+1, dir(135), dir(45));
	edged(i, i+1, dir(45), dir(135));
	edge(i, i+1);
}

void qq(int i)
{
	i = 2*i;
	edged(i, i+1, dir(155), dir(25));
	edged(i, i+1, dir(120), dir(60));
	edged(i, i+1, dir(60), dir(120));
	edged(i, i+1, dir(25), dir(155));
}

graph(v, 1);
for (int i=0; i<nl-1; ++i)
	edge(2*i+1, 2*i+2);
pp(0);
tt(1);
qq(2);
pp(3);
for (int i=0; i<nr-1; ++i) {
	edge(right + 2*i+1, right + 2*i+2);
}
for (int i=0; i<nr; ++i)
	pp(nl+i);
edged(0, right, dir(-65), dir(65));
edged(right-1, right+2*nr-1, dir(65), dir(-65));

label("\tenrm rovnice", (0, h/2), 4W);
label("\tenrm proměnné", (2, h/2), 4E);

/*** Párovací gadget ***/

picture b = ads_sub_pic();
vertex_size = 0.1;

real bh = 2;
real bw = 4;
real bm = 1;
real bw2 = bw - 2*bm;

pair w[] = {
	(0, 0),
	(bw, 0),
	(0, bh),
	(bw, bh),
};
for (int i=0; i<4; ++i) {
	real x = bm + bw2*i/3;
	w.push((x, 0));
	w.push((x, bh/2));
	w.push((x, bh));
}

graph(w, v_invisible);
for (int i=0; i<w.length; ++i)
	vertex(i, (i >= 4) ? v_white : v_shadow);

// Dolní cesta
edge(0, 4);
edge(4, 7);
edge(7, 10);
edge(10, 13);
edge(13, 1);

// Horní cesta
edge(2, 6);
edge(6, 9);
edge(9, 12);
edge(12, 15);
edge(15, 3);

// Šprušle
for (int i=0; i<4; ++i) {
	edge(4+3*i, 4+3*i+1);
	edge(4+3*i+1, 4+3*i+2);
}

/*** Main ***/

currentpicture = g;
add(centered(a), (0, 0));
add(centered(b), (6, 0));
