import ads;

vertex_size = 0.27;
real u = 1.8;

pair t[] = {
	(0, 0) * u,
	dir(0) * u,
	dir(60) * u,
};

pair d = (3.5, 0);

pair v[] = {
	t[0], t[1], t[2],
	t[0] + d, t[1] + d, t[2] + d,
	t[0] + 2d, t[1] + 2d, t[2] + 2d,
};

graph(v, 1);
edge(0, 1); edge(0, 2); edge(1, 2);
edge(3, 4); edge(3, 5); edge(4, 5);
edge(6, 7); edge(6, 8); edge(7, 8);

string lab[] = {
	"y", "z", "x",
	"\lnot y", "\lnot z", "x",
	"\lnot y", "p", "\lnot x",
};

for (int i=0; i<9; ++i) {
	label("$" + lab[i] + "$", v[i]);
}

edged(2, 8, dir(20), dir(-20));
edged(5, 8, dir(10), dir(-10));
edged(1, 4, dir(-30), dir(30));
edged(0, 3, dir(-30), dir(30));
edged(0, 6, dir(-35), dir(35));
