import ads;

vertex_size = 0.15;

void tedge(pair x, pair y, pen p)
{
	draw(x + vertex_size*unit(y-x) -- y, p);
}

void triple(pair t, real angle, pair i, pair j, pair k, pen color, pen thickness)
{
	pair u = (0,0);
	pair v = (1,0);
	pair w = dir(60);
	path p = shift(-(u+v+w)/3) * (u -- v -- w -- cycle);
	path pp = shift(t) * rotate(angle) * scale(0.3) * p;
	filldraw(pp, color, thickness);
	tedge(i, relpoint(pp, 0), thickness);
	tedge(j, relpoint(pp, 1/3), thickness);
	tedge(k, relpoint(pp, 2/3), thickness);
}

