import ads;

picture main = currentpicture;
vertex_size = 0.25;
real u = 1;
real t = 2;

picture kkl(int k, int l)
{
	picture p = ads_sub_pic();

	pair v[];
	for (int i=0; i<k; ++i)
		v[i] = (0, -(i-k/2.)*u);
	for (int j=0; j<l; ++j)
		v[k+j] = (t, -(j-l/2)*u);

	graph(v, 1);

	for (int i=0; i<k; ++i)
		label("\strut $a_" + (string)(i+1) + "$", v[i]);
	for (int j=0; j<l; ++j)
		label("\strut $b_" + (string)(j+1) + "$", v[k+j]);

	for (int i=0; i<k; ++i)
		for (int j=0; j<l; ++j)
			edge(v[i], v[k+j]);
	
	return p;
}

picture pk13 = kkl(1, 3);
picture pk22 = kkl(2, 2);
picture pk23 = kkl(2, 3);

// Vše dohromady

currentpicture = main;
add(centered(pk13), (0,0));
add(centered(pk22), (4,0));
add(centered(pk23), (8,0));
