import ads;
import trees;

picture p = currentpicture;

pair u[] = complete_binary_tree(2.5, 0.8, 4);

// "Stínové" vrcholy pod listy a jejich hodnoty
for (int i=0; i<8; ++i)
	u[16+i] = u[8+i] - (0,0.8);
int r[] = { 3, 4, 7, 4, 8, 12, 5, 9 };

tree_init(u);

void is(int k[], int d[], int f[]) {
	for (int i=2; i<=15; ++i)
		tree_edge((int)(i/2), i, (f[i] >= 1 ? thick : thin));

	for (int i=1; i<=15; ++i) {
		if (i < 8) {
			tree_num(i, k[i], (f[i] >= 2 ? v_lightgray : v_white));
			if (d[i] != 0)
				label("$\scriptstyle +" + (string) d[i] + "$", current_graph[i], (i%2==0 ? 2.5NNW : 2.5NNE));
		} else {
			tree_ext(i, size=0.9, (f[i] >= 2 ? v_lightgray : v_white));
			tree_num(i, k[i], v_invisible);
			if (d[i] != 0)
				label("$\scriptstyle +" + (string) d[i] + "$", current_graph[i], 2.5S);
		}
	}

	for (int i=0; i<8; ++i)
		label("$\scriptstyle( " + (string) r[i] + ")$", current_graph[16+i]);
}

void bracket(int i, int j)
{
	pair d = (u[9] - u[8])/2;
	pair s = (0, 0.95);
	pair t = (0, 1.05);
	draw (u[i]-d-s -- u[i]-d-t -- u[j]+d-t -- u[j]+d-s);
}

/*** Po intervalovém updatu ***/

picture p1 = ads_sub_pic();

int k1[] = {
	0,
	3,
	3, 2,
	3, 1, 5, 2,
	3, 1, 4, 1, 5, 9, 2, 6,
};

int d1[] = {
	0,
	0,
	0, 3,
	0, 3, 0, 0,
	0, 3, 0, 0, 0, 0, 0, 0,
};

int f1[] = {
	0,
	1,
	1, 2,
	1, 2, 0, 0,
	0, 2, 0, 0, 0, 0, 0, 0,
};

is(k1, d1, f1);
bracket(9, 15);

/*** Po dotazu, který něco líně vyhodnotí ***/

picture p2 = ads_sub_pic();

int k2[] = {
	0,
	3,
	3, 5,
	3, 4, 8, 2,
	3, 1, 4, 1, 8, 9, 2, 6,
};

int d2[] = {
	0,
	0,
	0, 0,
	0, 0, 0, 3,
	0, 3, 3, 3, 0, 3, 0, 0,
};

int f2[] = {
	0,
	0,
	1, 1,
	0, 2, 1, 0,
	0, 0, 0, 0, 2, 0, 0, 0,
};

is(k2, d2, f2);
bracket(10, 12);

/*** Main ***/

currentpicture = p;
add(centered(p1), (0,0));
add(centered(p2), (5.8,0));
