import ads;

real u = 0.35;

picture f(int x[])
{
	picture p;
	for (int i=0; i<=4; ++i) {
		draw(p, (i,0)*u -- (i,4)*u, ((i==0 || i==4) ? halfthick : thin));
		draw(p, (0,i)*u -- (4,i)*u, ((i==0 || i==4) ? halfthick : thin));
	}
	for (int i=0; i<4; ++i) {
		for (int j=0; j<4; ++j) {
			int c = x[4*(3-i)+j];
			if (c > 0) {
				label(p, '\sevenrm' + (string) c, (j+.5,i+.5)*u);
			} else {
				fill(p, (j,i)*u -- (j, i+1)*u -- (j+1,i+1)*u -- (j+1,i)*u -- cycle, agray);
				draw(p, (j,i)*u -- (j, i+1)*u -- (j+1,i+1)*u -- (j+1,i)*u -- cycle);
			}
		}
	}
	return shift(-2u, -2u) * p;
}

int a[][] = {
	{ 1, 2, 3, 4, 5, 0, 7, 8, 9, 6, 11, 12, 13, 10, 14, 15 },
	{ 1, 2, 3, 4, 0, 5, 7, 8, 9, 6, 11, 12, 13, 10, 14, 15 },
	{ 1, 2, 3, 4, 5, 7, 0, 8, 9, 6, 11, 12, 13, 10, 14, 15 },
	{ 1, 0, 3, 4, 5, 2, 7, 8, 9, 6, 11, 12, 13, 10, 14, 15 },
	{ 1, 2, 3, 4, 5, 6, 7, 8, 9, 0, 11, 12, 13, 10, 14, 15 },
};

add(currentpicture, f(a[0]));
add(currentpicture, shift(-6u,0) * f(a[1]));
add(currentpicture, shift(6u,0) * f(a[2]));
add(currentpicture, shift(0,6u) * f(a[3]));
add(currentpicture, shift(0,-6u) * f(a[4]));

draw((2u,0) -- (4u,0), e_biarrow);
draw((-2u,0) -- (-4u,0), e_biarrow);
draw((0,2u) -- (0,4u), e_biarrow);
draw((0,-2u) -- (0,-4u), e_biarrow);

// draw((-10u,0) -- (-8u,0), e_biarrow);
draw((10u,0) -- (8u,0), e_biarrow);

draw((0,-8u) -- (0,-10u), e_biarrow);

draw((8u,2u) -- (8u,2u) + 2u*dir(45), e_biarrow);
draw((8u,-2u) -- (8u,-2u) + 2u*dir(-45), e_biarrow);
draw((-8u,2u) -- (-8u,2u) + 2u*dir(135), e_biarrow);
draw((-8u,-2u) -- (-8u,-2u) + 2u*dir(-135), e_biarrow);

draw((2u,6u) -- (4u,6u), e_biarrow);
draw((-2u,6u) -- (-4u,6u), e_biarrow);
draw((2u,-6u) -- (4u,-6u), e_biarrow);
draw((-2u,-6u) -- (-4u,-6u), e_biarrow);
