import ads;

real u = 1;

pair v[] = {
	(0, 2) * u,
	(1, 2) * u,
	(0, 0) * u,
	(1, 0) * u,
	(3, 0.5) * u,
	(3, 1.5) * u,
};

graph(v);

edge(0, 1, thick);
label("$e$", (v[0]+v[1])/2, 2N);

edge(2, 3, thick);
label("$f$", (v[2]+v[3])/2, 2S);

edge(4, 5, thick);
label("$g$", (v[4]+v[5])/2, 2E);

path p = v[0] {left} .. (-0.7, 1)*u .. {right} v[2];
path q = v[1] {right} .. (1.7, 1)*u .. {left} v[3];
draw(p);
draw(q);
label("$C$", (-0.7,1)*u, 2W);

path r = v[2] {up} .. {right} v[5];
path s = v[3] {up} .. {right} v[4];
draw(r);
draw(s);
label("$D$", v[5] - (.7u,0), N);

pair x = intersectionpoint(q, r);
pair y = intersectionpoint(q, s);
vertex(x);
vertex(y);
label("$x$", x, 1.5*NNE);
label("$y$", y, SE);
