import ads;

real u = 0.5;

pair ea = (0,2) * u;
pair eb = (3,2) * u;
pair fa = (0,-2) * u;
pair fb = (3,-2) * u;
pair ga = (0,0) * u;
pair gb = (3,0) * u;
pair pl = (-1,0) * u;
pair pru = (4,1) * u;
pair prd = (4,-1) * u;

vertex(ea);
label("$a$", ea, NW);
vertex(eb);
label("$b$", eb, NE);
edge(ea, eb);
label("$e$", (ea+eb)/2, N);

vertex(fa);
vertex(fb);
edge(fa, fb, thick);
label("$f$", (fa+fb)/2, N);

edge(ga, gb, shortdashed);

vertex(pl);
vertex(pru);
vertex(prd);
edge(ea, pl, thick);
edge(pl, fa, thick);
edge(fb, prd, thick);
edge(prd, pru, thick);
edge(pru, eb, thick);
label("$P$", (pl+fa)/2, 1.5*W);

real tip = 0.3;
edge(pl, pl + tip*W);
edge(pru, pru + tip*dir(40));
edge(prd, prd + tip*dir(-40));

draw(
	(1,0)*u .. (0,-3)*u .. (-2,0)*u .. (0,3)*u .. cycle
);
draw(
	(2,0)*u .. (3,-3)*u .. (5,0)*u .. (3,3)*u .. cycle
);

label("$A$", (-2.5,2)*u);
label("$B$", (5.5,2)*u);
label("$R$", (1.5,0.8)*u);
