import ads;
import mst;

mst_running_example();

picture g = currentpicture;

picture g1 = ads_sub_pic();
mscale = 1;
mst_graph();
mst_weights();

// Budeme simulovat chod Kruskalova algoritmu

int ee[][] = new int[12][5];		// Pro každou hranu: w, srci, srcj, dsti, dstj
int ei = 0;
for (int i=0; i<3; ++i) {
	for (int j=0; j<3; ++j) {
		if (i < 2) {
			ee[ei][0] = horiz_weights[j][i];
			ee[ei][1] = i;
			ee[ei][2] = j;
			ee[ei][3] = i+1;
			ee[ei][4] = j;
			++ei;
		}
		if (j < 2) {
			ee[ei][0] = vert_weights[j][i];
			ee[ei][1] = i;
			ee[ei][2] = j;
			ee[ei][3] = i;
			ee[ei][4] = j+1;
			++ei;
		}
	}
}
ee = sort(ee);

int comp[] = new int[9];
for (int i=0; i<9; ++i)
	comp[i] = i;

void union(int i, int j) {
	int ci = comp[i];
	int cj = comp[j];
	for (int k=0; k<9; ++k)
		if (comp[k] == ci)
			comp[k] = cj;
}

picture h[] = new picture[9];
h[0] = ads_sub_pic();
mscale = 0.4;
mst_background();

int s = 0;
for (int i=0; i<12; ++i) {
	int v1 = 3*ee[i][1] + ee[i][2];
	int v2 = 3*ee[i][3] + ee[i][4];
	// write(ee[i][0]);
	if (comp[v1] != comp[v2]) {
		union(v1, v2);
		++s;
		h[s] = h[s-1].copy();
		currentpicture = h[s];
		edge(v(ee[i][1], ee[i][2]), v(ee[i][3], ee[i][4]), quarterthick);
	}
}

picture g2 = ads_sub_pic();
for (int i=0; i<3; ++i) {
	for (int j=0; j<3; ++j) {
		int s = 3*i + j;
		add(h[s].fit(), i*(0,-1.5) + j*(1.5,0));
	}
}

currentpicture = g;
add(centered(g1));
add(centered(g2), (5,0));
