import ads;
import trees;

/* Předtím */

pair u[];
real s = 1;
u[0] = (0, 0);			// otec
u[1] = u[0] + (-1.3, -s);	// s kým slučujeme
u[2] = u[0] + (0, -s);		// podtečený vrchol
u[3] = u[0] + (1.3, -s);	// d
u[4] = u[1] + (-0.3, -s);	// a
u[5] = u[1] + (0.3, -s);	// b
u[6] = u[2] + (0, -s);		// c

tree_init(u);

real d = 0.1;
real dd = 0.18;
ab_edge(0, 1, -dd);
ab_edge(0, 2);
ab_edge(0, 3, dd);
ab_edge(1, 4, -d);
ab_edge(1, 5, d);
ab_edge(2, 6);

tree_elliptic_node(0, "{\bf 4}\;7");
tree_elliptic_node(1, "\bf 2");
tree_elliptic_node(2, mode=v_bold);

tree_node(4, "a");
tree_node(5, "b");
tree_node(6, "c");
tree_node(3, "d");

label("$v$", u[2], 3NNW);
label("$\ell$", u[1], (0, 3NNW.y));

draw(u[0] + 0.7W -- u[0] + 0.3W, e_smallarrow);
label("$o$", u[0] + 0.7W, 0.5W);

/* Potom */

pair v[];
real s = 1;
v[0] = (5, 0);			// otec
v[1] = v[0] + (-0.7, -s);	// sloučený vrchol
v[2] = v[0] + (0.7, -s);	// d
v[3] = v[1] + (-0.5, -s);	// a
v[4] = v[1] + (0, -s);		// b
v[5] = v[1] + (0.5, -s);	// c

tree_init(v);

real d = 0.1;
real dd = 0.18;
ab_edge(0, 1, -d);
ab_edge(0, 2, d);
ab_edge(1, 3, -dd);
ab_edge(1, 4);
ab_edge(1, 5, dd);

tree_elliptic_node(0, "7");
tree_elliptic_node(1, "\bf 2\;4");

tree_node(3, "a");
tree_node(4, "b");
tree_node(5, "c");
tree_node(2, "d");

/* Šipka */

draw((2,-0.3) -- (3.1,-0.3), e_arrow);
