import ads;
import trees;

/* Předtím */

pair u[];
real s = 1;
u[0] = (0, 0);			// otec
u[1] = u[0] + (-1.2, -s);	// a
u[2] = u[0] + (0, -s);		// přeplněný vrchol
u[3] = u[0] + (1.2, -s);	// f
u[4] = u[2] + (-0.9, -s);	// b
u[5] = u[2] + (-0.3, -s);	// c
u[6] = u[2] + (0.3, -s);	// d
u[7] = u[2] + (0.9, -s);	// e

tree_init(u);

real d = 0.1;
real dd = 0.18;
ab_edge(0, 1, -dd);
ab_edge(0, 2);
ab_edge(0, 3, dd);
ab_edge(2, 4, -dd);
ab_edge(2, 5, -d);
ab_edge(2, 6, d);
ab_edge(2, 7, dd);

tree_elliptic_node(0, "2\;8", elong=1.5);
tree_elliptic_node(2, "4\;{\bf 5}\;6", elong=1.5, mode=v_bold);

tree_node(1, "a");
tree_node(4, "b");
tree_node(5, "c");
tree_node(6, "d");
tree_node(7, "e");
tree_node(3, "f");

/* Potom */

pair v[];
real s = 1;
v[0] = (5, 0);			// otec
v[1] = v[0] + (-1.7, -s);	// a
v[2] = v[0] + (-0.65, -s);	// levá polovina
v[3] = v[0] + (0.65, -s);	// pravá polovina
v[4] = v[0] + (1.7, -s);	// f
v[5] = v[2] + (-0.3, -s);	// b
v[6] = v[2] + (0.3, -s);	// c
v[7] = v[3] + (-0.3, -s);	// d
v[8] = v[3] + (0.3, -s);	// e

tree_init(v);

real d = 0.1;
real dd = 0.18;
ab_edge(0, 1, -1.5dd);
ab_edge(0, 2, -0.5d);
ab_edge(0, 3, 0.5d);
ab_edge(0, 4, 1.5dd);
ab_edge(2, 5, -d);
ab_edge(2, 6, d);
ab_edge(3, 7, -d);
ab_edge(3, 8, d);

tree_elliptic_node(0, "2\;{\bf 5}\;8", elong=1.5, mode=v_bold);
tree_elliptic_node(2, "4");
tree_elliptic_node(3, "6");

tree_node(1, "a");
tree_node(5, "b");
tree_node(6, "c");
tree_node(7, "d");
tree_node(8, "e");
tree_node(4, "f");

/* Šipka */

draw((1.8,-0.3) -- (2.9,-0.3), e_arrow);
