import ads;
import trees;

pair e = bst_edge;
pair le = rotate(-45) * e;
pair re = rotate(45) * e;
pair le2 = rotate(-45) * e * 0.7;
pair re2 = rotate(45) * e * 0.7;

/*** Předtím ***/

pair u[];
u[0] = (0, 0);
u[1] = u[0] + re;
u[2] = u[0] + le;
u[3] = u[1] + le2;
u[4] = u[1] + re2;
u[5] = u[0] + bst_mini;

tree_init(u);
tree_edge(0, 1);

pair d = unit(u[0] - u[2]);
draw(u[2] -- u[0] - d*vertex_size, thick, e_smallarrow);

tree_edge(0, 5);
tree_edge(1, 3);
tree_edge(1, 4);
tree_node(0, "x");
label("$+2$", u[0], 2*ENE);
tree_node(1, "y");
label("$+$", u[1], 2*ENE);
tree_sub_ht(2, "A", "h");
tree_sub_ht(3, "B", "h");
tree_sub_ht(4, "C", "h+1");

rbracket(u[4].x + 2.3*tree_sub_size, br_top_vertex(1), br_bot_sub(3), "h+2");

/*** Poté ***/

pair v[];
v[0] = (6, 0);
v[1] = v[0] + le;
v[2] = v[0] + re;
v[3] = v[1] + le2;
v[4] = v[1] + re2;
v[5] = v[0] + bst_mini;

tree_init(v);
tree_edge(0, 1);
tree_edge(0, 2);
draw(v[0] -- v[5], thick, e_smallarrow);
tree_edge(1, 3);
tree_edge(1, 4);
tree_node(0, "y");
label("$0$", v[0], 2.5*WNW);
tree_node(1, "x");
label("$0$", v[1], 2.5*WNW);
tree_sub_ht(2, "C", "h+1");
tree_sub_ht(3, "A", "h");
tree_sub_ht(4, "B", "h");

lbracket(v[3].x - 2*tree_sub_size, br_top_vertex(1), br_bot_sub(4), "h+1");

/*** Šipka ***/

draw((2.5, -0.1) -- (3.5, -0.1), Arrow(size=6));
