import ads;
import trees;

pair e = bst_edge;
pair le = rotate(-45) * e;
pair re = rotate(45) * e;
pair le1 = rotate(-60) * e * 1.2;
pair re1 = rotate(60) * e * 1.2;
pair le2 = rotate(-45) * e * 0.7;
pair re2 = rotate(45) * e * 0.7;

/*** Předtím ***/

pair u[];
u[0] = (0, 0);			// x
u[1] = u[0] + re1;		// y
u[2] = u[1] + le;		// z
u[3] = u[0] + rotate(-70) * e * 1.4;	// A
u[4] = u[1] + re;		// D
u[5] = u[2] + le2;		// B
u[6] = u[2] + re2;		// C
u[7] = u[0] + bst_mini;

tree_init(u);
pair d = unit(u[0] - u[3]);
draw(u[3] -- u[0] - d*vertex_size, thick, e_smallarrow);
tree_edge(0, 1);
tree_edge(1, 2);
tree_edge(0, 3);
tree_edge(0, 7);
tree_edge(1, 4);
tree_edge(2, 5);
tree_edge(2, 6);
tree_node(0, "x");
label("$+2$", u[0], 2*ENE);
tree_node(1, "y");
label("$-$", u[1], 2*NE);
tree_node(2, "z");
tree_sub_ht(3, "A", "h");
tree_sub_ht(4, "D", "h");
tree_sub_ht(5, "B", "h^-");
tree_sub_ht(6, "C", "h^-");

rbracket(u[4].x + 2*tree_sub_size, br_top_vertex(1), br_bot_sub(5), "h+2");
lbracket(u[5].x - 2*tree_sub_size, br_top_vertex(2), br_bot_sub(5), "h+1", lpos=0.8);

/*** Poté ***/

pair v[];
v[0] = (7, 0);			// z
v[1] = v[0] + le1;		// x
v[2] = v[0] + re1;		// y
v[3] = v[1] + le2;		// A
v[4] = v[1] + re2;		// B
v[5] = v[2] + le2;		// C
v[6] = v[2] + re2;		// D
v[7] = v[0] + bst_mini;

tree_init(v);
tree_edge(0, 1);
tree_edge(0, 2);
draw(v[0] -- v[7], thick, e_smallarrow);
tree_edge(1, 3);
tree_edge(1, 4);
tree_edge(2, 5);
tree_edge(2, 6);
tree_node(0, "z");
label("$0$", v[0], 2.5*ENE);
tree_node(1, "x");
tree_node(2, "y");
tree_sub_ht(3, "A", "h");
tree_sub_ht(4, "B", "h^-");
tree_sub_ht(5, "C", "h^-");
tree_sub_ht(6, "D", "h");

lbracket(v[3].x - 2*tree_sub_size, br_top_vertex(1), br_bot_sub(3), "h+1");
rbracket(v[6].x + 2*tree_sub_size, br_top_vertex(2), br_bot_sub(6), "h+1");

/*** Šipka ***/

draw((3, -0.2) -- (4, -0.2), Arrow(size=6));
