import ads;
import trees;

pair e = bst_edge;
pair le = rotate(-45) * e;
pair re = rotate(45) * e;
pair le1 = rotate(-50) * e;
pair re1 = rotate(50) * e;
pair le2 = rotate(-22.5) * e;
pair re2 = rotate(22.5) * e;
pair le3 = rotate(-11.25) * e;
pair re3 = rotate(11.25) * e;

tree_node_size = 0.1;
tree_sub_aspect = 1.5;

real lab_depth = 0.6;

/*** Hloubka 0 ***/

pair v0[];
v0[0] = (0, 0);

tree_init(v0);
tree_node(0);

label("$A_0=1$", (v0[0].x, lab_depth));

/*** Hloubka 1 ***/

pair v1[];
v1[0] = (2, 0);
v1[1] = v1[0] + le2;

tree_init(v1);
tree_edge(0, 1);
tree_node(0);
tree_node(1);

label("$A_1=2$", (v1[0].x, lab_depth));

/*** Hloubka 2 ***/

pair v2[];
v2[0] = (4, 0);
v2[1] = v2[0] + le2;
v2[2] = v2[1] + le3;
v2[3] = v2[0] + re2;

tree_init(v2);
tree_edge(0, 1);
tree_edge(0, 3);
tree_edge(1, 2);
tree_node(0);
tree_node(1);
tree_node(2);
tree_node(3);

label("$A_2=4$", (v2[0].x, lab_depth));

/*** Hloubka 3 ***/

pair v3[];
v3[0] = (6.5, 0);
v3[1] = v3[0] + le1;
v3[2] = v3[1] + le2;
v3[3] = v3[2] + le3;
v3[4] = v3[1] + re2;
v3[5] = v3[0] + re1;
v3[6] = v3[5] + le2;

tree_init(v3);
tree_edge(0, 1);
tree_edge(1, 2);
tree_edge(1, 4);
tree_edge(2, 3);
tree_edge(0, 5);
tree_edge(5, 6);
tree_node(0);
tree_node(1);
tree_node(2);
tree_node(3);
tree_node(4);
tree_node(5);
tree_node(6);

label("$A_3=7$", (v3[0].x, lab_depth));

/*** Obecný případ ***/

pair vn[];
vn[0] = (10, 0);
vn[1] = vn[0] + le;
vn[2] = vn[0] + re;

tree_init(vn);
tree_edge(0, 1);
tree_edge(0, 2);
tree_node(0);
tree_sub_ht(1, "", "h-1");
tree_sub_ht(2, "", "h-2");

label("$A_h=A_{h-1}+A_{h-2}+1$", (vn[0].x, lab_depth));
