import ads;
import trees;

pair t[] = complete_binary_tree(1.7, 0.8, 4);
tree_init(t);
vertex_size = 0.13;

void e(int i)
{
	tree_edge((int)(i/2), i);
}

void v(int i, int n)
{
	tree_node(i);
	label("$\scriptstyle " + (string)n + "$", t[i]);
}

// Minimální

for (int i=2; i<=7; ++i)
	e(i);

v(1, 4);
v(2, 2);
v(3, 2);
v(4, 1);
v(5, 1);
v(6, 1);
v(7, 1);

// Střední

for (int i=1; i<t.length; ++i)
	t[i] += (4, 0);

e(2);
e(3);
e(4);
e(5);
e(6);
e(7);
e(14);
e(15);

v(1, 5);
v(2, 2);
v(3, 3);
v(4, 1);
v(5, 1);
v(6, 1);
v(7, 2);
v(14, 1);
v(15, 1);

// Maximální

for (int i=1; i<t.length; ++i)
	t[i] += (4, 0);

for (int i=2; i<=15; ++i)
	e(i);

for (int i=1; i<=15; ++i)
	v(i, (i<2) ? 8 : (i<4) ? 4 : (i<8) ? 2 : 1);

// Popisky

label("$\le$", (2,-0.5));
label("$\le$", (6,-0.5));
