import ads;

pair p(real i, real j)
{
	return (0.6*i, 0.6*j);
}

for (int i=-4; i<=4; ++i)
	for (int j=-2; j<=2; ++j)
		draw(circle(p(i,j), 0.1));

fill(circle(p(0,0), 0.1));

draw(box(p(0,0) - (0.2, 0.2), p(4,2) + (0.2, 0.2)), halfthick);

real r = 0.3;
draw(arc(p(-4,0), r, 90, 270) -- arc(p(4,0), r, -90, 90) -- cycle, middashed);

label("$\ge p$", p(4,2) + (0.6,0.1));

for (int i=-4; i<4; ++i)
	label("$\scriptstyle <$", p(i+0.5,0));

for (int i=-2; i<2; ++i)
	label(rotate(-90) * Label("$\scriptstyle >$"), p(-5,i+0.5));

label("$p$", filltype=Fill(white), p(0,0), 1.5NE);

// Chceme symetrický obrázek
draw(p(-7,0) -- p(7,0), invisible);
