import ads;
import trees;

// Vyvážený strom

pair t[] = complete_binary_tree(2, 1, 3);
tree_init(t);

for (int i=2; i<=7; ++i)
	tree_edge((int)(i/2), i);

for (int i=4; i<=7; ++i)
	for (int j=0; j<2; ++j) {
		pair d = dir(-90 + 45*(j-0.5)) * 0.5;
		draw(t[i] -- t[i]+d);
	}

for (int i=1; i<=7; ++i)
	tree_elliptic_node(i, elong=1);

label("\strut $\scriptstyle n$", t[1]);
for (int i=2; i<=3; ++i)
	label("\strut $\scriptstyle n/2$", t[i]);
for (int i=4; i<=7; ++i)
	label("\strut $\scriptstyle n/4$", t[i]);

// Nevyvážený strom

pair s[];
s[0] = (0,0);
s[1] = (0,0);
s[2] = s[1] + (0.5, -1);
s[3] = s[2] + (0.5, -1);
s[4] = s[1] + (-0.5, -1);
s[5] = s[2] + (-0.5, -1);
tree_init(s);

for (int i=0; i<s.length; ++i)
	s[i] += (4,0);

tree_edge(1, 2);
tree_edge(2, 3);
tree_edge(1, 4);
tree_edge(2, 5);

for (int j=0; j<2; ++j) {
	pair d = dir(-90 + 45*(j-0.5)) * 0.5;
	draw(s[3] -- s[3]+d);
}

for (int i=1; i<=5; ++i)
	tree_elliptic_node(i, elong=1);

label("\strut $\scriptstyle n$", s[1]);
label("\strut $\scriptstyle n-1$", s[2]);
label("\strut $\scriptstyle n-2$", s[3]);
label("\strut $\scriptstyle 1$", s[4]);
label("\strut $\scriptstyle 1$", s[5]);
