import ads;

picture conf(int c[][])
{
	picture main = currentpicture;
	picture p = ads_sub_pic();

	// Podložka
	draw((-0.6, 0) -- (0.6, 0), halfthick);
	// Trny
	pair t[] = { (-0.32,0), (0,0), (0.32,0) };
	for (int i=0; i<3; ++i)
		draw(t[i] -- t[i] + (0,0.45), halfthick);
	// Disky
	real dh = 0.1;
	real du = 0.11;
	for (int i=0; i<3; ++i)
		for (int j=0; j<c[i].length; ++j) {
			real dw = du * c[i][j];
			pair c = t[i] + (0,dh)*(j+0.5) + (0, line_width_user(halfthick)/2);
			filldraw(box(c - (dw/2,dh/2), c + (dw/2,dh/2)), agray, black);
		}

	currentpicture = main;
	return p;
}

// Konfigurace

picture p[] = {
	conf(new int[][] { {3,2,1}, {}, {} } ),
	conf(new int[][] { {3,2}, {1}, {} } ),
	conf(new int[][] { {3}, {1}, {2} } ),
	conf(new int[][] { {3}, {}, {2,1} } ),
	conf(new int[][] { {}, {3}, {2,1} } ),
	conf(new int[][] { {1}, {3}, {2} } ),
	conf(new int[][] { {1}, {3,2}, {} } ),
	conf(new int[][] { {}, {3,2,1}, {} } ),
};

pair dd = (1.5,0);
for (int i=0; i<p.length; ++i) {
	add(centered(p[i]), dd*i);
	label("\tenrm " + (string)i, dd*i + (0,0.65));
}

// "Kóty"

texpreamble("\font\cc=cscsc10\def\hanoj{\hbox{\cc Hanoj}}");

pair dim[] = { dd*0, dd*3, dd*4, dd*7 };
string dtext[] = { "\hanoj(2;A,C,B)", "A\rightarrow B", "\hanoj(2;C,B,A)" };
for (pair d: dim)
	draw(d - (0,0.5) -- d - (0,1.3));

for (int i=0; i<3; ++i) {
	pair di = dim[i] - (0,1.2);
	pair dj = dim[i+1] - (0,1.2);
	draw(di -- dj, e_smallbiarrow);
	label("\strut $" + dtext[i] + "$", 0.5(di+dj), N);
}
