import ads;
import graph;

real f(real x)
{
	return 1/x;
}

picture p;
size(p, 150, 150, IgnoreAspect);

filldraw(p, (1,0) -- graph(p, f, 1, 5, 50) -- (5,0) -- cycle, area_gray, black);
draw(p, graph(p, f, 1/1.3, 1, 20), hair);
draw(p, graph(p, f, 5, 5.8, 10), hair);

xaxis(p, xmin=0, xmax=5.8, p=hair, ticks=Ticks(Step=1, Size=3));
yaxis(p, ymin=0, ymax=1.3, p=hair, ticks=Ticks(Step=1, Size=3));;
label(p, "$x$", (5.8, 0), 2S);
label(p, "$y$", (0, 1.3), 1.5W);

for (int i=2; i<=5; ++i)
	filldraw(p, box((i-1,0), (i,f(i))), agray, black);

for (int i=1; i<=4; ++i)
	draw(p, box((i,0), (i+1,f(i))), middashed);

add(p.fit(), (0,0));
