import ads;
import trees;

tnode t(int parent_id, real rangle, int key, int pri, pair pri_dir=NW)
{
	tnode v = tn_add(parent_id, rangle);
	v.draw_vertex = new void (tnode w) {
		vertex(w.id, v_white);
		label("\eightrm " + (string) key, w.pos);
		label("\eightrm " + (string) pri, w.pos, 2.5*pri_dir);
	};
	return v;
}

pair q(int parent_id, real rangle)
{
	tnode v = tn_add(parent_id, rangle);
	v.draw_vertex = new void (tnode w) { };
	return v.pos;
}

void case1(pair p)
{
	tn_init(p);
	t(-1, 0, 3, 1);		// 0
	t(0, -40, 2, 4);	// 1
	t(1, -20, 1, 8);	// 2
	t(0, +40, 7, 3, NE);	// 3
	t(3, -30, 5, 5);	// 4
	t(3, 30, 8, 9, NE);	// 5
	t(4, -20, 4, 6);	// 6
	t(4, 20, 6, 7, NE);	// 7
	tn_draw();
}

void case2(pair p)
{
	tn_init(p);
	t(-1, 0, 3, 1);		// 0
	t(0, -40, 2, 4);	// 1
	t(1, -20, 1, 8);	// 2
	tnode a = t(0, +40, 7, 3, NE);	// 3
	a.draw_edge = new void (tnode w) { draw(current_graph[0] -- interp(current_graph[0], current_graph[3], 0.6), shortdashed); };
	t(3, -30, 5, 5);	// 4
	t(3, 30, 8, 9, NE);	// 5
	t(4, -20, 4, 6);	// 6
	t(4, 20, 6, 7, NE);	// 7
	tn_draw();
}

void case3(pair p)
{
	tn_init(p);
	t(-1, 0, 3, 1);		// 0
	t(0, -40, 2, 4);	// 1
	t(1, -20, 1, 8);	// 2
	tnode a = t(0, +40, 0, 0);	// 3
	a.draw_vertex = new void (tnode w) { };
	a.draw_edge = new void (tnode w) { draw(current_graph[0] -- interp(current_graph[0], current_graph[3], 0.6), shortdashed); };
	tn_draw();

	tn_init(p + (2, 0));
	t(-1, 0, 7, 3);		// 0
	t(0, 30, 8, 9, NE);	// 1
	tnode b = t(0, -30, 0, 0);	// 2
	b.draw_vertex = new void (tnode w) { };
	b.draw_edge = new void (tnode w) { draw(current_graph[0] -- interp(current_graph[0], current_graph[2], 0.6), shortdashed); };
	tn_draw();

	tn_init(interp(a.pos, b.pos, 0.5));
	t(-1, -0, 5, 5);	// 0
	t(0, -20, 4, 6);	// 1
	t(0, 20, 6, 7, NE);	// 2
	tn_draw();
}

void case4(pair p)
{
	tn_init(p);
	t(-1, 0, 3, 1);		// 0
	t(0, -40, 2, 4);	// 1
	t(1, -20, 1, 8);	// 2
	t(0, +40, 5, 5, NE);	// 3
	t(3, -20, 4, 6);	// 4
	tn_draw();

	tn_init(p + (2.5, 0));
	t(-1, 0, 7, 3);		// 0
	t(0, 30, 8, 9, NE);	// 1
	t(0, -30, 6, 7);	// 2
	tn_draw();
}

case1((0, 0));
case2((8, 0));
case3((0, -5));
case4((7, -5));

draw((3.5, -0.5) -- (4.5, -0.5), e_arrow);
draw((5.6, -2.7) -- (3, -4.2), e_arrow);
draw((3.5, -6.5) -- (4.5, -6.5), e_arrow);
