#!/usr/bin/perl
use common::sense;
use List::Util qw(min);

my @x = split //, "poutník";
my @y = split //, "potemník";
my ($n, $m) = (scalar @x, scalar @y);

my @t;
$t[$_][$m] = $n-$_ for 0..$n;
$t[$n][$_] = $m-$_ for 0..$m;

for my $i (reverse 0..$n-1) {
	for my $j (reverse 0..$m-1) {
		my $c = ($x[$i] eq $y[$j]) ? 0 : 1;
		$t[$i][$j] = min($c + $t[$i+1][$j+1], 1 + $t[$i+1][$j], 1 + $t[$i][$j+1])
	}
}

for my $i (0..$n) {
	for my $j (0..$m) {
		print $t[$i][$j], " ";
	}
	print "\n";
}
