#!/usr/bin/perl
use common::sense;

my @w = (
	0,
	1,
	10,
	3,
	2,
	1,
	9,
);

my $n = @w-1;

my @T;
my @K;
for my $i (1..$n+1) {
	$T[$i][$i-1] = 0;
}

for my $l (1..$n) {
	for my $i (1..$n-$l+1) {
		my $j = $i+$l-1;
		my $W = 0;
		$W += $w[$_] for $i..$j;
		$T[$i][$j] = 1000000;
		for my $k ($i..$j) {
			my $C = $T[$i][$k-1] + $T[$k+1][$j] + $W;
			if ($C < $T[$i][$j]) {
				$T[$i][$j] = $C;
				$K[$i][$j] = $k;
			}
		}
	}
}

print "# W\n";
for my $i (1..$n) {
	print "$i => ", $w[$i], "\n";
}

print "\n# T\n";
for my $i (1..$n+1) {
	print join("&", $i, map { $T[$i][$_] // '--' } 0..$n), "\\cr\n";
}

print "\n# K\n";
for my $i (1..$n) {
	print join("&", $i, map { $K[$i][$_] // '--' } 1..$n), "\\cr\n";
}
