import ads;

// Stavy

pair v[] = new pair[15];
pair d = (0,-1);
vertex_size = 0.1;

v[0] = (0,0);
v[1] = 1.5*dir(-155);
v[2] = v[1] + d;
v[3] = v[2] + d;
v[4] = v[3] + d;
v[5] = scale(-1,1) * v[1];
v[6] = v[5] + d;
v[7] = v[6] + d;
v[8] = v[7] + 1.3*dir(-145);
v[9] = v[8] + d;
v[10] = v[9] + d;
v[11] = v[7] + 1.3*dir(-35);
v[12] = v[11] + d;
v[13] = v[12] + d;
v[14] = v[13] + d;

graph(v, 1);

// Koncové stavy

vertex(3, 0);
vertex(4, 0);
vertex(7, 0);
vertex(10, 0);
vertex(14, 0);

// Dopředné hrany

void dp(int i, int j, string c, pair d=1.5W)
{
	arc(i, j, halfthick, e_smallarrow);
	label("\strut\tt " + c, interp(v[i], v[j], 0.5), d);
}

dp(0, 1, "a", 0.3NW);
dp(1, 2, "r");
dp(2, 3, "a");
dp(3, 4, "b");
dp(0, 5, "b", 0.3NE);
dp(5, 6, "a", 1.5E);
dp(6, 7, "r", 1.5E);
dp(7, 8, "a", 0.3NW);
dp(8, 9, "b");
dp(9, 10, "a");
dp(7, 11, "b", 0.3NE);
dp(11, 12, "a", 1.5E);
dp(12, 13, "r", 1.5E);
dp(13, 14, "a", 1.5E);

// Zpětné hrany

pen z = thin;
arrowbar a = e_smallarrow;

arcd(1, 0, dir(110), dir(-55), z, a);
arcd(2, 0, dir(35), N, z, a);
arcd(3, 1, dir(155), dir(25), z, a);
arcd(4, 5, dir(45), dir(25), z, a);
arcd(5, 0, dir(70), -dir(55), z, a);
arcd(6, 1, dir(170), dir(170), z, a);
arcd(7, 2, dir(170), dir(170), z, a);
arcd(8, 3, dir(170), dir(170), z, a);
arcd(9, 4, dir(170), dir(170), z, a);
arcd(10, 6, dir(30), dir(45), z, a);
arcd(11, 5, dir(70), dir(155), z, a);
arcd(12, 6, dir(30), dir(155), z, a);
arcd(13, 7, dir(160), dir(85), z, a);
arcd(14, 8, dir(170), dir(135), z, a);

// Zkratky

pen zz = shortdashed;
arrowbar aa = e_smallarrow;

arcd(8, 3, dir(100), dir(200), zz, aa);
arcd(9, 4, dir(200), dir(100), zz, aa);
arcd(13, 7, dir(125), dir(125), zz, aa);
arcd(14, 3, dir(190), dir(20), zz, aa);
