import ads;

string jehla = "barbarossa";
int n = length(jehla);

pair v[] = new pair[n+1];
for (int i=0; i<=n; ++i)
	v[i] = (1, 0) * i;

vertex_size = 0.1;
graph(v, 1);

for (int i=0; i<=n; ++i) {
	// Popisky vrcholů
	if (i == 0)
		label("$\scriptstyle\varepsilon$", v[0], 2N);
	else if (i <= 6 || i == n)
		label("\font\x=cmtt10 at 8pt\x " + substr(jehla, 0, i), v[i], 2N);
	else if (i == 8)
		label("$\ldots$", v[i], 2N);

	// Dopředná hrana
	if (i < n) {
		arc(i, i+1, halfthick, e_smallarrow);
		label("\strut\tt " + substr(jehla, i, 1), interp(v[i], v[i+1], 0.5), S);
	}
}

// Zpětné hrany
pen z = thin;
arrowbar a = e_smallarrow;

pair u = (0, 0.5);
pair d = (0, -0.5);
pair s = (0, -0.3);
pair t = (0, -1);
pair t2 = (0, -1);
arcd(v[1]+u, v[0]+u, dir(135), -dir(45), z, a);
edged(v[2]+s, v[1]+t, dir(-110), W, z);
edged(v[3]+s, v[2]+t, dir(-110), W, z);
arcd(v[4]+u, v[1]+u, dir(135), -dir(45), z, a);
arcd(v[5]+u, v[2]+u, dir(135), -dir(45), z, a);
arcd(v[6]+u, v[3]+u, dir(135), -dir(45), z, a);
edged(v[7]+s, v[6]+t, dir(-110), W, z);
edged(v[8]+s, v[7]+t, dir(-110), W, z);
edged(v[9]+s, v[8]+t, dir(-110), W, z);
draw(v[10]+s {dir(-110)} .. {W} v[9]+t2+0.5W -- v[1]+t2 {W} .. {N} v[0]+s, z, a);
