import ads;

picture g = currentpicture;

pair z = (-1, 0);
pair a = (0, 0.6);
pair b = (0, -0.6);
pair s = (1, 0);

picture base = ads_sub_pic();
vertex(z);	label("$z$", z, 1.5*W);
vertex(a);	label("$a$", a, 1.5*N);
vertex(b);	label("$b$", b, 1.5*S);
vertex(s);	label("$s$", s, 1.5*E);
arc(z, a, e_smallarrow);
arc(z, b, e_smallarrow);
arc(a, b, e_smallarrow);
arc(a, s, e_smallarrow);
arc(b, s, e_smallarrow);

picture h1 = ads_sub_pic();
draw(z--a--b--s, gray(0.7) + roundcap + 2mm);
add(base);

picture h2 = ads_sub_pic();
draw(z--a--s, gray(0.7) + roundcap + 2mm);
draw(z--b--s, gray(0.7) + roundcap + 2mm);
add(base);

currentpicture = g;

add(centered(h1), (0,0));
add(centered(h2), (3.25,0));
