import ads;

real w = 8;		// Šířka celé sítě
real h = 0.5;		// Výška krabičky
real dv = 0.5;		// Vertikální mezera mezi krabičkami
real dh = 0.5;		// Horizontální mezera mezi krabičkami

for (int r=0; r<3; ++r) {
	int nk = 2^r;	// Počet krabiček na řádek
	for (int k=0; k<nk; ++k) {
		// x-ové meze krabičky
		real x0 = w * k/nk;
		real x1 = w * (k+1)/nk;
		if (k > 0) x0 += dh/2;
		if (k < nk-1) x1 -= dh/2;

		// y-ové meze
		real y0 = -r*(h+dv);
		real y1 = y0 - h;

		// krabička
		draw(box((x0, y0), (x1, y1)));
		label("$S_{" + (string)(2^(3-r)) + "}$", interp((x0, y0), (x1, y1), 1/2));

		// drát shora
		draw((interp(x0, x1, 1/2), y0+dv) -- (interp(x0, x1, 1/2), y0), e_smallarrow);

		// z poslední hladiny dráty dolů
		if (r == 2) {
			draw((interp(x0, x1, 1/4), y1) -- (interp(x0, x1, 1/4), y1-dv), e_smallarrow);
			draw((interp(x0, x1, 3/4), y1) -- (interp(x0, x1, 3/4), y1-dv), e_smallarrow);
			label("$<$", (interp(x0, x1, 1/2), y1-dv));
			if (k > 0)
				label("$<$", (x0-dh/2, y1-dv));
		}

		// "<" mezi krabičkami
		if (k > 0)
			label("$<$", (x0-dh/2, interp(y0, y1, 1/2)));
	}
}
