import ads;
import fortune;

real sf = 12.5/1024;
transform s = shift(0,4) * scale(sf,-sf);

pair pts[] = { s*(341.333, 270.000), s*(614.400, 320.000), s*(682.667, 220.000) };
pair cc = s*(500.899, 169.215);
real cr = sf*188.729;
pair sw = s*(0, 320.800);
pair p1c = s*(341.333, 295.400);
real p1a = -0.009842520 / sf;
pair p2c = s*(614.400, 320.400);
real p2a = -0.625000000 / sf;
pair p3c = s*(682.667, 270.400);
real p3a = -0.004960317 / sf;
pair isec[] = { s*(583.375, -281.213), s*(654.164, -667.816), s*(602.981, 238.903), s*(624.727, 253.748) };

path bbox = box((0,0), (10,6));
//draw(bbox, dashed);

// Paraboly a kusy pobřeží
path p1 = parabola(p1c, p1a, bbox);
path p2 = parabola(p2c, p2a, bbox, 0.01);
path p3 = parabola(p3c, p3a, bbox);
path b1 = firstcut(p1, p3).before;
path b2 = firstcut(firstcut(p3, p1).after, p2).before;
path b3 = lastcut(firstcut(p2, p3).after, p3).before;
path b4 = lastcut(p3, p2).after;

// Paraboly
draw(p1, shortdashed);
draw(p2, shortdashed);
draw(p3, shortdashed);

// Pobřežní linie
draw(b1);
draw(b2);
draw(b3);
draw(b4);

pair c13 = interp(pts[0], pts[2], 0.5);
pair d13 = unit(pts[2] - pts[0]) * dir(-90);
path o13 = c13 - 20*d13 -- c13 + 20*d13;
pair is13 = intersectionpoint(p1, p3);
path s13 = (-100, is13.y) -- (100, is13.y);
draw(firstcut(firstcut(o13, bbox).after, s13).before, thick);
draw(firstcut(lastcut(o13, bbox).before, s13).after, middashed);

pair c23 = interp(pts[1], pts[2], 0.5);
pair d23 = unit(pts[2] - pts[1]) * dir(-90);
path o23 = c23 - 20*d23 -- c23 + 20*d23;
path s23 = (-100, isec[2].y) -- (100, isec[2].y);
path t23 = (-100, isec[3].y) -- (100, isec[3].y);
draw(firstcut(firstcut(o23, bbox).after, s23).before, middashed);
draw(firstcut(firstcut(o23, s23).after, t23).before, thick);
draw(firstcut(lastcut(o23, bbox).before, t23).after, middashed);

// Zametací přímka
draw(sw -- sw+(10,0));
label("$p$", sw+(9.5,0), N);

// Body
epoint(pts[0]);
epoint(pts[1]);
epoint(pts[2]);
