import ads;
import fortune;

real sf = 12.5/1024;
transform s = shift(0,4) * scale(sf,-sf);

pair pts[] = { s*(341.333, 168.000), s*(512.000, 68.000), s*(682.667, 118.000) };
pair cc = s*(535.562, 303.847);
real cr = sf*237.021;
pair sw = s*(0, 340.000);
pair p1c = s*(341.333, 254.000);
real p1a = -0.002906977/sf;
pair p2c = s*(512.000, 204.000);
real p2a = -0.001838235/sf;
pair p3c = s*(682.667, 229.000);
real p3a = -0.002252252/sf;
pair isec[] = { s*(-380.059, -1258.813), s*(475.633, 201.569), s*(566.408, 198.558), s*(2314.445, -5768.076) };

path bbox = box((0,0), (10,6));
// draw(bbox, dashed);

// Paraboly a kusy pobřeží
path p1 = parabola(p1c, p1a, bbox);
path p2 = parabola(p2c, p2a, bbox);
path p3 = parabola(p3c, p3a, bbox);
path b1 = firstcut(p1, p2).before;
path b2 = firstcut(firstcut(p2, p1).after, p3).before;
path b3 = firstcut(p3, p2).after;

// Oblast za pobřežím
filldraw((0,6) -- b1 -- b2 -- b3 -- (10,6) -- cycle, area_gray, area_gray);

// Paraboly
draw(p1, shortdashed);
draw(p2, shortdashed);
draw(p3, shortdashed);

// Pobřežní linie
draw(b1);
draw(b2);
draw(b3);

// Osy
pair c12 = interp(pts[0], pts[1], 0.5);
pair d12 = unit(pts[1] - pts[0]) * dir(-90);
path o12 = c12 - 20*d12 -- c12 + 20*d12;
path s12 = (-100, isec[1].y) -- (100, isec[1].y);
draw(firstcut(firstcut(o12, bbox).after, s12).before, thick);
draw(firstcut(lastcut(o12, bbox).before, s12).after, middashed);

pair c23 = interp(pts[1], pts[2], 0.5);
pair d23 = unit(pts[2] - pts[1]) * dir(-90);
path o23 = c23 - 20*d23 -- c23 + 20*d23;
path s23 = (-100, isec[1].y) -- (100, isec[1].y);
draw(firstcut(firstcut(o23, bbox).after, s23).before, thick);
draw(firstcut(lastcut(o23, bbox).before, s23).after, middashed);

// Zametací přímka
draw(sw -- sw+(10,0));
label("$p$", sw+(9.5,0), N);

// Body
epoint(pts[0]);
epoint(pts[1]);
epoint(pts[2]);
