import ads;
import trees;

// Magická posunutí hran
pair e = 1.5*bst_edge;
pair le1 = rotate(-50) * e;
pair re1 = rotate(50) * e;
pair le2 = rotate(-22.5) * e;
pair re2 = rotate(22.5) * e;

// Původní strom
pair u[];
u[0] = (0, 0);
u[1] = u[0] + le1;
u[2] = u[1] + le2;
u[3] = u[1] + re2;
u[4] = u[0] + re1;
u[5] = u[4] + le2;

// Nové kusy
pair v[];
pair vv = (0.8, 0);
v[0] = u[0] + vv;
v[1] = u[4] + vv;
v[2] = u[4] + re2 + vv;

tree_init(u);
tree_edge(0, 1);
tree_edge(0, 4);
tree_edge(1, 2);
tree_edge(1, 3);
tree_edge(4, 5);

draw(v[0] -- u[1]);
draw(v[0] -- v[1]);
draw(v[1] -- u[5]);
draw(v[1] -- v[2]);

tree_init(u);
tree_num(0, 6);
tree_num(1, 3);
tree_num(2, 2);
tree_num(3, 4);
tree_num(4, 8);
tree_num(5, 7);

tree_init(v);
tree_num_inverse(0, 6);
tree_num_inverse(1, 8);
tree_num_inverse(2, 9);
