import ads;

pair A = (0, 0);
pair B = (1.7, 0.5);
pair M = interp(A, B, 0.5);
pair AB = unit(B-A);

path p = M + AB*dir(90)*3 -- M + AB*dir(-90)*3;
fill(p -- reverse(shift(-1.5*AB) * p) -- cycle, area_gray);
draw(p, halfthick);

pair C = relpoint(p, 0.1);
draw(C + AB*dir(180)*0.1 -- C + AB*dir(180), halfthick, e_smallarrow);

pair D = relpoint(p, 0.9);
draw(D + AB*dir(180)*0.1 -- D + AB*dir(180), halfthick, e_smallarrow);

draw(A -- B, dashed);
epoint(A);
epoint(B);
label("$a$", A, 1.2SW);
label("$b$", B, 1.2NE);

label("$p$", relpoint(p, 0.15), E);
label("$B_a$", A + (-0.2, 1));
label("$B_b$", B + (-0.2, 1));
