import ads;

path a = (1.2, 2.5) -- (3.7, 3);
path b = (0.5, 0.7) -- (3.5, 3.5);
path c = (2, 0.8) -- (4, 2.7);
path d = (0, 2.9) -- (3.2, 0.2);
path e = (0.2, 0.5) -- (2.4, 0.1);

draw(a);
draw(b, halfthick);
draw(c, halfthick);
draw(d, halfthick);
draw(e);

label("$a$", point(a, 0.2), 1.5N);
label("$b$", point(b, 0.1), NW);
label("$c$", point(c, 0.5), SE);
label("$d$", point(d, 0.9), NE);
label("$e$", point(e, 0.5), N);

real z = 2;
draw((-1, z) -- (5, z), dashed);

void epast(pair x)
{
	epoint(x);
}

void efuture(pair x)
{
	fpoint(x);
}

epast(point(a, 0));
epast(point(a, 1));
efuture(point(b, 0));
epast(point(b, 1));
efuture(point(c, 0));
epast(point(c, 1));
epast(point(d, 0));
efuture(point(d, 1));
efuture(point(e, 0));
efuture(point(e, 1));

epast(intersectionpoint(a, b));
efuture(intersectionpoint(b, d));
