import ads;
import markers;

real u = 2;
real uu = 1.3u;

draw((-uu,0) -- (uu,0), middashed);
draw((0,-uu) -- (0,uu), middashed);
draw(circle((0,0), u));

label("$1$", (1,0)*u, 2SE);
label("$-1$", (-1,0)*u, 2SW);
label("$\bf i$", (0,1)*u, 2NE);
label("$-\bf i$", (0,-1)*u, 2SE - (0.3,0));

pair x = u * dir(42);
pair y = 1.7x;

draw((0,0) -- y);
draw((x.x,0) -- x);
draw((0,0) -- (x.x,0));

label("$\sin\varphi$", (x.x, 0.4x.y), E, UnFill(ymargin=1));
label("$\cos\varphi$", (0.5x.x, 0), S);
markangle("$\varphi$", (1,0), (0,0), x, radius=20, e_smallarrow);
label("$\vert z\vert \cdot (\cos\varphi + {\bf i}\sin\varphi)$", y, 2SE);

epoint(x);
fpoint(y);
