import ads;
import markers;

real u = 2;
real uu = 1.3u;

draw((-uu,0) -- (uu,0), middashed);
draw((0,-uu) -- (0,uu), middashed);
draw(circle((0,0), u));

pair z = dir(360/5) * u;
draw((0,0) -- (1,0)*u);
draw((0,0) -- z);
markangle("$2\pi\over 5$", (1,0), (0,0), z, radius=20, e_smallarrow);

void o(int i, pair d)
{
	pair x = dir(360/5*i) * u;
	epoint(x);
	string s = "$\omega^" + (string) i;
	if (i == 0)
		s += "= \omega^5";
	label(s + "$", x, d);
}

o(0, 1.5SE);
o(1, 1.5NE);
o(2, NW);
o(3, 1.5SW);
o(4, 0.7SE);
