import ads;

picture main = currentpicture;
picture pic = ads_sub_pic();

real u = 1.5;

pair v[];
v[0] = (0, 0);
v[1] = u*N;
v[2] = v[1] + u*dir(120);
v[3] = v[1] + u*dir(60);
v[4] = v[0] + u*dir(-120);
v[5] = v[0] + u*dir(-60);
v[6] = v[5] + u*dir(30);

graph(v);

pen q = halfthick;
edge(0, 1, q);
edge(1, 2, q);
edge(1, 3, q);
edge(0, 4, q);
edge(0, 5, q);
edge(5, 6, q);

pen p = shortdashed;
arrowbar a = e_smallarrow;
arcd(0, 1, dir(150), dir(30), p, a);
arcd(1, 2, dir(180), dir(30), p, a);
arcd(2, 3, dir(30), dir(-30), p, a);
arcd(3, 5, dir(-60), dir(-120), p, a);
arcd(5, 6, dir(60), dir(-40), p, a);
arcd(6, 4, dir(-100), dir(120), p, a);
arcd(4, 0, dir(140), dir(10), p, a);

currentpicture = main;
add(rotate(80) * centered(pic), (0, 0));
