import ads;
import tdp;
unitsize(1.1cm);

vertex_size = 0.15/1.1;

pair a = (-1,4);
pair bdir = 1.5*dir(-135);
pair b = a+bdir;
pair c = b+bdir;

pair p = scale(-1,1)*a;
pair q = scale(-1,1)*b;
pair r = scale(-1,1)*c;

pair x = (-1.5,0);
pair y = (0,0);
pair z = scale(-1,1)*x;

label("\rm Adam", a, Relative(2W));
label("\rm Boleslav", b, Relative(2W));
label("\rm Cecil", c, Relative(2W));

label("\rm Pavlína", p, Relative(2E));
label("\rm Qěta", q, Relative(2E));
label("\rm Radka", r, Relative(2E));

label("\rm Xaver", x, 3S);
label("\rm Yvaine", y, 3S);
label("\rm Zorro", z, 3S);

triple(x + 1.2*dir(100), 180, p, c, x, agray, halfthick);
triple(y + 1.2*dir(90), 180, q, b, y, agray, halfthick);
triple(z + 1.2*dir(80), 180, r, a, z, agray, halfthick);
triple((0,2), 30, x, q, a, white, thin);

// Vrcholy musíme kreslit nakonec, aby se ořízly přesahy hran

vertex(a, 1);
vertex(b, 1);
vertex(c, 1);

vertex(p, 1);
vertex(q, 1);
vertex(r, 1);

vertex(x, 1);
vertex(y, 1);
vertex(z, 1);
