import ads;

picture main = currentpicture;
pair d = (0, 1);

vertex_size = 0.1;

// Levý graf: mosty a artikulace

picture pl = ads_sub_pic();

pair v[] = { (0, 0) };
v[1] = v[0] + d*dir(60);
v[2] = v[0] + d*dir(120);
v[3] = v[2] - d;
v[4] = v[0] + d*dir(-90);
v[5] = v[4] + d*dir(-45);
v[6] = v[4] + d*dir(-135);
v[7] = v[6] + d*dir(-45);
v[8] = v[6] + d*dir(210);
v[9] = v[6] + d*dir(150);

graph(v, v_invisible);
vertex(0, v_gray);
vertex(1, v_white);
vertex(2, v_gray);
vertex(3, v_white);
vertex(4, v_gray);
vertex(5, v_white);
vertex(6, v_gray);
vertex(7, v_white);
vertex(8, v_white);
vertex(9, v_white);

edge(0, 1);
edge(0, 2);
edge(1, 2);
edge(2, 3, thick);

edge(0, 4, thick);
edge(4, 5);
edge(4, 6);
edge(5, 7);
edge(6, 7);

edge(6, 8);
edge(6, 9);
edge(8, 9);

// Pravý graf: větší řezy

picture pr = ads_sub_pic();

pair v[] = { (0, 0) };
for (int i=0; i<6; ++i) {
	v[i+1] = v[0] + d*dir(i*360/6);
}
v[7] = v[0] + 2*v[5].x;
for (int i=0; i<6; ++i) {
	v[i+8] = v[7] + d*dir(i*360/6);
}

graph(v, v_white);
vertex(v[5], v_gray);
vertex(v[6], v_gray);

for (int i=0; i<6; ++i) {
	edge(0, 1+i);
	if (i != 4)
		edge(1+i, 1 + (i+1) % 6);
	edge(7, 8+i);
	if (i != 1)
		edge(8+i, 8 + (i+1) % 6);
}

edge(2, 0, thick);
edge(2, 1, thick);
edge(2, 3, thick);

// Vše dohromady

currentpicture = main;
add(centered(pl), (0,0));
add(centered(pr), (5,0));
