import ads;

picture main = currentpicture;
real r = 1;

// K_4

picture pk4 = ads_sub_pic();
real r = 1.4;

pair k4[] = {
	(0, 0),
	r * dir(90),
	r * dir(210),
	r * dir(-30),
};

fill(k4[0] -- k4[1] -- k4[2] -- cycle, gray(0.4));
fill(k4[0] -- k4[2] -- k4[3] -- cycle, gray(0.6));
fill(k4[0] -- k4[1] -- k4[3] -- cycle, gray(0.8));

graph(k4);
for (int i=0; i<4; ++i)
	for (int j=i+1; j<4; ++j)
		edge(i, j);

// První divný

picture pd = ads_sub_pic();
real s = 1.4;

pair d[] = {
	s * dir(0),
	s * dir(120),
	s * dir(-120),
	1.4*s * dir(180),
	0.3s * dir(0),
	0.3s * dir(120),
	0.3s * dir(-120),
};

fill(d[0] -- d[1] -- d[2] -- cycle, gray(0.8));
fill(d[1] -- d[2] -- d[3] -- cycle, gray(0.6));
fill(d[4] -- d[5] -- d[6] -- cycle, gray(0.4));

graph(d);

edge(0, 1);
edge(0, 2);
edge(1, 2);

edge(1, 3);
edge(2, 3);

edge(4, 5);
edge(4, 6);
edge(5, 6);

edge(0, 4);

// Druhý divný

picture pe = ads_sub_pic();
real s = 1.4;

pair e[] = {
	0.5s,
	0.7s * dir(90),
	0.7s * dir(-90),
	-0.5s,
	1.4s - 0.3s * dir(0),
	1.4s - 0.3s * dir(120),
	1.4s - 0.3s * dir(-120),
};

fill(e[0] -- e[1] -- e[2] -- cycle, gray(0.8));
fill(e[1] -- e[2] -- e[3] -- cycle, gray(0.6));
fill(e[4] -- e[5] -- e[6] -- cycle, gray(0.4));

graph(e);

edge(0, 1);
edge(0, 2);
edge(1, 2);

edge(1, 3);
edge(2, 3);

edge(4, 5);
edge(4, 6);
edge(5, 6);

edge(0, 4);

// Vše dohromady

currentpicture = main;
add(centered(pk4), (0,0));
add(centered(pd), (4,0));
add(centered(pe), (8.5,0));
