import ads;

picture main = currentpicture;
pair d = (0, 1);

// První strom

picture t1 = ads_sub_pic();

pair v1[] = { (0, 0) };
v1[1] = v1[0] + d;
v1[2] = v1[1] + d;
v1[3] = v1[1] + d * dir(-50);
v1[4] = v1[1] + d * dir(50);
v1[5] = v1[2] + d * dir(-60);
v1[6] = v1[2] + d * dir(-30);
v1[7] = v1[2] + d;
v1[8] = v1[2] + d * dir(30);
v1[9] = v1[2] + d * dir(60);

graph(v1);

edge(0, 1);
edge(1, 2);
edge(1, 3);
edge(1, 4);
edge(2, 5);
edge(2, 6);
edge(2, 7);
edge(2, 8);
edge(2, 9);

// Druhý strom

picture t2 = ads_sub_pic();

pair v2[] = { (0, 0) };
v2[1] = v2[0] + d * dir(-60);
v2[2] = v2[1] + d * dir(-120);

graph(v2);

edge(0, 1);
edge(1, 2);

// Třetí strom

picture t3 = ads_sub_pic();

pair v3[] = { (0, 0) };
for (int i=1; i<=7; ++i)
	v3[i] = v3[0] + d * dir(i*360/7);

graph(v3);

for (int i=1; i<=7; ++i)
	edge(0, i);

// Vše dohromady

currentpicture = main;
add(centered(t1), (0,0));
add(centered(t2), (3.5,0));
add(centered(t3), (7,0));
